-- name=ho_hosafe1
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hosafe1" );
  game.relations[ "ho_hosafe1" ].exitroom = "rm_cellar1";
  private.room_objname = "ho_hosafe1";
  private.task_name = "win_hosafe1";  
  
  private.pairs = { "", "" };
  private.win_hosafe1 = {};  

  private.Animations();  

  --------------------------------------------------------------------------------------------
  -- function opn_hosafe1 () end;
  --------------------------------------------------------------------------------------------
  local opn_hosafe1 = function ()

  end;

  cmn.AddSubscriber( "opn_hosafe1", opn_hosafe1, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hosafe1_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_money1", "spr_hosafe1_win" );
      ObjDelete( "gho_cellar1_hosafe1" );
      ObjDelete( "spr_hosafe1_panel" );     
      ObjDelete( "anm_hosafe1_coin_fin" );

    end;

  end;
  cmn.AddSubscriber( "win_hosafe1", win_hosafe1_func );
  --------------------------------------------------------------------------------------------------
  local start_hosafe1_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

        common_impl.ProcessHoStart( "hosafe1" );

    end;
      
    local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

    for i = 1, #ho_found, 1 do

      ObjDelete( ho_found[ i ][ "object" ] );

    end;

  end;
  cmn.AddSubscriber( "win_hosafe1", start_hosafe1_func, "ho_hosafe1" );
  --------------------------------------------------------------------------------------------------
  private.win_hosafe1.task = { "obj_1_1", "obj_1_2", "obj_2_1", "obj_2_2", "obj_3_1", "obj_3_2", "obj_4_1", "obj_4_2", "obj_5_1", "obj_5_2", 
                             "obj_6_1", "obj_6_2", "obj_7_1", "obj_7_2", "obj_8_1", "obj_8_2", 
                             --"obj_9_1", "obj_9_2", "obj_10_1", "obj_10_2", 
                             --"obj_11_1", "obj_11_2", "obj_12_1", "obj_12_2" 
                             };

  for i = 1, #private.win_hosafe1.task do

    ObjSet( "spr_hosafe1_"..private.win_hosafe1.task[ i ], { event_mdown = function () private.ClkItem( private.win_hosafe1.task[ i ] ); end } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );  
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hosafe1" );

  end;

  if ( not cmn.IsEventDone( "opn_hosafe1" ) ) then

      cmn.SetEventDone( "opn_hosafe1" );
      cmn.CallEventHandler( "opn_hosafe1" );
    
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].stage = 0;   

  end;        

  local ho_tasks = {};
  
  interface.TaskPanelTaskAdd( ho_tasks, "obj_1_1",      1, 0, { { "spr_hosafe1_obj_1_1","spr_hosafe1_obj_1_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_1_2",      1, 0, { { "spr_hosafe1_obj_1_2","spr_hosafe1_obj_1_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_2_1",      1, 0, { { "spr_hosafe1_obj_2_1","spr_hosafe1_obj_2_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_2_2",      1, 0, { { "spr_hosafe1_obj_2_2","spr_hosafe1_obj_2_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_3_1",      1, 0, { { "spr_hosafe1_obj_3_1","spr_hosafe1_obj_3_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_3_2",      1, 0, { { "spr_hosafe1_obj_3_2","spr_hosafe1_obj_3_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_4_1",      1, 0, { { "spr_hosafe1_obj_4_1","spr_hosafe1_obj_4_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_4_2",      1, 0, { { "spr_hosafe1_obj_4_2","spr_hosafe1_obj_4_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_5_1",      1, 0, { { "spr_hosafe1_obj_5_1","spr_hosafe1_obj_5_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_5_2",      1, 0, { { "spr_hosafe1_obj_5_2","spr_hosafe1_obj_5_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_6_1",      1, 0, { { "spr_hosafe1_obj_6_1","spr_hosafe1_obj_6_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_6_2",      1, 0, { { "spr_hosafe1_obj_6_2","spr_hosafe1_obj_6_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_7_1",      1, 0, { { "spr_hosafe1_obj_7_1","spr_hosafe1_obj_7_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_7_2",      1, 0, { { "spr_hosafe1_obj_7_2","spr_hosafe1_obj_7_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_8_1",      1, 0, { { "spr_hosafe1_obj_8_1","spr_hosafe1_obj_8_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "obj_8_2",      1, 0, { { "spr_hosafe1_obj_8_2","spr_hosafe1_obj_8_1" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_9_1",      1, 0, { { "spr_hosafe1_obj_9_1","spr_hosafe1_obj_9_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_9_2",      1, 0, { { "spr_hosafe1_obj_9_2","spr_hosafe1_obj_9_1" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_10_1",     1, 0, { { "spr_hosafe1_obj_10_1","spr_hosafe1_obj_10_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_10_2",     1, 0, { { "spr_hosafe1_obj_10_2","spr_hosafe1_obj_10_1" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_11_1",     1, 0, { { "spr_hosafe1_obj_11_1","spr_hosafe1_obj_11_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_11_2",     1, 0, { { "spr_hosafe1_obj_11_2","spr_hosafe1_obj_11_1" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_12_1",     1, 0, { { "spr_hosafe1_obj_12_1","spr_hosafe1_obj_12_2" } } );
  --interface.TaskPanelTaskAdd( ho_tasks, "obj_12_2",     1, 0, { { "spr_hosafe1_obj_12_2","spr_hosafe1_obj_12_1" } } );  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  
  if ( private.pairs[1] == "" ) then 
    
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";
    
  end; 
 
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1 );
  --cmn.StopAllEnv( "audio/level1/env/aud_ho_hosafe1_env" );
  --cmn.PlayAudio( "env", "audio/level1/env/aud_ho_hosafe1_env", 1, 1 );
  --cmn.PlayAudio( "mus", "audio/aud_ho_game1_mus", 1, 1 );    

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );

  cmn.TutorialShow( "tutorial_ho4" );
  cmn.TutorialSetShown( "tutorial_ho4" );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hosafe1_panel", "ho_hosafe1" );
  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 0.5 );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  int.Lock( false );    

  ObjSet( "spr_hosafe1_"..name, { input = 0 } );

  if ( private.pairs[1] == "" ) then

     private.pairs[1] = name;
     
     for i = 1, #private.win_hosafe1.task do
       
       if string.find( private.win_hosafe1.task[ i ], private.pairs[1] ) then

          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = private.pairs[1];
          
       end;
       
     end;
   
     int.Lock( true );
     private.AttachObj( name, 1 );

  else

     private.pairs[2] = name;
     int.Lock( true );
     private.AttachObj( name, 2 );

  end;

end;
--*********************************************************************************************************************
function private.ClkItem ( name )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hosafe1_click" );
  --cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_click" );
  for i = 1, #private.win_hosafe1.task do

      if ( private.win_hosafe1.task[i] == name ) then

          private.CompleteTask( name );

          ObjSet( "spr_hosafe1_"..name, { input = 0 } ); 

          break;

      end; 

  end;              

end;
--*********************************************************************************************************************
function private.AttachObj ( name, pos )

  local spr = "spr_hosafe1_"..name.."_obj";
  local item_add = "spr_hosafe1_"..name.."_add";

  local func_end = function ()

      private.Check();

  end;

  ObjDelete( spr );
  ObjCreate( spr, "spr" );

  ObjSet( spr, { alp = 0, res = "assets/levels/level1/ho_hosafe1/layers/inv/"..name } );

  ObjAnimate( "txt_hosafe1_task", "alp", 0, 0, "", 
  { 
    0,0,ObjGet( "txt_hosafe1_task" ).alp, 
    0.3,0,0 
  });

  ObjAnimate( spr, "alp", 0, 0, "", 
  { 
    0,0,0, 
    0.3,0,1 
  });

  ObjAnimate( item_add, "alp", 0, 0, "", 
  { 
    0.0,  0,  ObjGet( item_add ).alp,
    0.3,  0,  1
  } );     

  ObjAnimate( "obj_hosafe1_obj"..pos, "scale_xy", 0, 0, func_end, 
  { 
    0,0,0.7,0.7, 
    0.2,0,0.7,0.7, 
    0.4,0,0.7,0.7
  });
  
  ObjAttach( spr , "obj_hosafe1_obj"..pos );

end;
--*********************************************************************************************************************
function private.Check ()

  int.Lock( false );

  if ( private.pairs[1] ~= "" and private.pairs[2] ~= "" ) then

     local pairs1_full_len = string.len( private.pairs[1] );
     local pairs_len1 = string.sub( private.pairs[1], 1, pairs1_full_len-2 );
     local pairs2_full_len = string.len( private.pairs[2] );
     local pairs_len2 = string.sub( private.pairs[2], 1, pairs2_full_len-2 );
   
     if ( pairs_len1 == pairs_len2 ) then

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hosafe1_right_comb" );
        int.Lock( true );
        private.AnimateStage();
        
     else 

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hosafe1_wrong_comb" );

        int.Lock( true );

        local func_end = function ()

            private.Default();

        end;

        for i = 1,2 do

            ObjAnimate( "obj_hosafe1_obj"..i, "ang", 0, 0, "", 
            { 
              0,0,0, 
              0.1,0,0.2,
              0.3,0,-0.2,
              0.4,0,0
            });

        end;

        ObjAnimate( "ho_hosafe1", "alp", 0, 0, func_end, 
        { 
          0,0,1, 
          0.5,0,1 
        });

        private.Back();

     end;

  end;

end;
--*********************************************************************************************************************
function private.AnimateStage ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].stage = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].stage + 1;  
  
  cmn.HoTaskFind( "spr_hosafe1_"..private.pairs[1], private.pairs[ 1 ] );
  cmn.StopAudio( "sfx", "audio/aud_hide_sfx" );
  cmn.HoTaskFind( "spr_hosafe1_"..private.pairs[2], private.pairs[ 2 ] );

  common_impl.PassingHoCheck();

  --cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_home_ho_anim" );


  for i = 1,2 do

    ObjAnimate( "obj_hosafe1_obj"..i, "scale_xy", 0, 0, "", 
    { 
      0,0,ObjGet( "obj_hosafe1_obj"..i ).scale_x,ObjGet( "obj_hosafe1_obj"..i ).scale_y,
      0.3,0,ObjGet( "obj_hosafe1_obj"..i ).scale_x,ObjGet( "obj_hosafe1_obj"..i ).scale_y, 
      1,0,0.5,0.5
    });  

    ObjAnimate( "obj_hosafe1_obj"..i, "pos_xy", 0, 0, "", 
    { 
      0,0,ObjGet( "obj_hosafe1_obj"..i ).pos_x,ObjGet( "obj_hosafe1_obj"..i ).pos_y, 
      0.3,0,ObjGet( "obj_hosafe1_obj"..i ).pos_x,ObjGet( "obj_hosafe1_obj"..i ).pos_y, 
      1,0,0,32
    });  

  end;

  local func_end = function ()

    private.AnimatePFX();
    private.Stage();
    
    if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].stage == 8) then

     ObjSet( "anm_hosafe1_coin", { alp = 0 } );
     ObjSet( "anm_hosafe1_coin_fin", { alp = 1 } ); 
     cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hosafe1_anim_bag" );    
     AnimPlay( "anm_hosafe1_coin_fin", "DoAnim", "" );      

    else
     
     cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hosafe1_anim_bag" );
     AnimPlay( "anm_hosafe1_coin", "DoAnim", "" );      

    end;

  end;

  ObjAnimate( "ho_hosafe1", "alp", 0, 0, func_end, 
  { 
    0,0,1, 
    0.9,0,1 
  });
  
end;
--*********************************************************************************************************************
function private.AnimatePFX ()

  int.Lock( true );

  local func_end = function ()

      int.Lock( false );

  end;

  ObjAnimate( "ho_hosafe1", "alp", 0, 0, func_end, 
  { 
    0,0,1, 
    2,0,1
  });

  local collect_name  = "pfx_hosafe1_"..private.pairs[1].."_effect";
  ObjCreate( collect_name, "partsys" );

  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho_hint",
    pos_y = 20,
    active = 1, visible = 1, input = 0
  } );

  ObjAttach( collect_name, "obj_hosafe1_panel" );
  ObjSet(collect_name, { blendmode = 2, scale_x  = 1.7, scale_y  = 1.7, pos_z = 10 } );

  local func_end2 = function ()

      private.Default();

  end;

  ObjAnimate( "txt_hosafe1_task", "alp", 0, 0, func_end2, 
  { 
    0,0,ObjGet( "txt_hosafe1_task" ).alp, 
    1,0,ObjGet( "txt_hosafe1_task" ).alp, 
    1.3,0,1 
  });

  local spr1 = "spr_hosafe1_"..private.pairs[1].."_obj";
  local spr2 = "spr_hosafe1_"..private.pairs[2].."_obj";

  ObjAnimate( spr1, "alp", 0, 0, "", 
  { 
    0,0,1,
    0.3,0,0 
  });

  ObjAnimate( spr2, "alp", 0, 0, "", 
  { 
    0,0,1, 
    0.3,0,0 
  });

  ObjSet( "obj_hosafe1_obj1", { pos_x = -150, scale_x  = 0.7, scale_y = 0.7 } );
  ObjSet( "obj_hosafe1_obj2", { pos_x = 150, scale_x  = 0.7, scale_y = 0.7 } );

end;
--*********************************************************************************************************************
function private.Back ()

  for i = 1, #private.win_hosafe1.task do

      for j = 1,2 do

          if ( private.win_hosafe1.task[i] == private.pairs[j] ) then
              
              ObjSet( "spr_hosafe1_"..private.pairs[j], { input = 1 } );

          end;

      end;

  end;

end;
--*********************************************************************************************************************
function private.Default ()

  ObjSet( "obj_hosafe1_obj1", { pos_x = -150, scale_x  = 0.7, scale_y = 0.7 } );
  ObjSet( "obj_hosafe1_obj2", { pos_x = 150, scale_x  = 0.7, scale_y = 0.7 } );

  local spr1 = "spr_hosafe1_"..private.pairs[1].."_obj";
  local spr2 = "spr_hosafe1_"..private.pairs[2].."_obj";

  local item_add_1 = "spr_hosafe1_"..private.pairs[1].."_add";
  local item_add_2 = "spr_hosafe1_"..private.pairs[2].."_add";

  ObjAnimate( spr1, "alp", 0, 0, "", 
  { 
    0,0,ObjGet( spr1 ).alp,
    0.3,0,0 
  });

  ObjAnimate( spr2, "alp", 0, 0, "", 
  { 
    0,0,ObjGet( spr2 ).alp, 
    0.3,0,0 
  });

  private.pairs[1] = "";
  private.pairs[2] = "";
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].choose = "";
  
  local func_end = function ()

      int.Lock( false );

  end;

  ObjAnimate( "txt_hosafe1_task", "alp", 0, 0, func_end, 
  { 
    0,0,ObjGet( "txt_hosafe1_task" ).alp, 
    0.5,0,ObjGet( "txt_hosafe1_task" ).alp, 
    1,0,1 
  });
  
  if ( ObjGet( item_add_1 ) ) then
    
  ObjAnimate( item_add_1, "alp", 0, 0, "", 
  { 
    0.0,  0,  ObjGet( item_add_1 ).alp,
    0.3,  0,  0
  } ); 

  ObjAnimate( item_add_2, "alp", 0, 0, "", 
  { 
    0.0,  0,  ObjGet( item_add_2 ).alp,
    0.3,  0,  0
  } ); 
  
  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  private.Stage();
  ObjAttach( "obj_hosafe1_panel", "int_taskpanel_impl" );
  
end;

--*********************************************************************************************************************
function private.Stage ()

  for i = 1,ng_global.progress[ ng_global.currentprogress ][ private.task_name ].stage do

    ObjSet( "spr_hosafe1_light_add_"..i, { alp = 1 } );

  end; 

end;
--*********************************************************************************************************************
function private.Animations ()


end;
--*********************************************************************************************************************
--*********************************************************************************************************************