-- name=level1_inv
--*********************************************************************************************************************
function public.Init ()

  int.CreateDeployPlus( 1 );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level1_inv_deploy = function ()

    local visible_sparkle_ho = true;

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then

      visible_sparkle_ho = false;

    end;

    common_impl.TurnChildGfx( { "level1_inv_deploy" } , "level1_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level1_inv_deploy", update_game_mode_level1_inv_deploy, nil );

  private.init_ladybag1();
  private.init_wire1();
  private.init_emptyflask1();
  private.init_thread1();
  private.init_keypicture1();
  
  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level1_inv_hub");
    port.VideoResizeInRoom("level1_inv");
  end;
end;
--*********************************************************************************************************************
-- function *** ladybag1 *** () end;
--*********************************************************************************************************************
function private.init_ladybag1 ()

  ObjSet( "spr_deploy_inv_ladybag1_gatesamulet1_1", { event_mdown = private.get_gatesamulet1_1 } );
  ObjSet( "spr_deploy_inv_ladybag1_nuts1", { event_mdown = private.get_nuts1 } );
  ObjSet( "obj_deploy_inv_ladybag1_use_bagamulet1", { event_mdown = function() private.Ladybag1Clk() end } );
  ObjSet( "spr_deploy_inv_ladybag1_note", { event_mdown = private.clk_note1 } );

  --------------------------------------------------------------------------------------------
  -- function get_gatesamulet1_1 () end;
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gatesamulet1_1" ] =
  {
    type = "get",
    get_obj = "spr_deploy_inv_ladybag1_gatesamulet1_1",
    room = "int_deploy_inv",
    zz = "deploy_inv_ladybag1",
    zz_gate = "inv_ladybag1"
  };
  --------------------------------------------------------------------------------------------
  local get_gatesamulet1_1_inv = function ()
  
    int.InventoryItemAdd( "inv_gatesamulet1", "spr_deploy_inv_ladybag1_gatesamulet1_1", "assets/levels/level1/common_inventory1/inv_bag1/inv/inv_gatesamulet1_1" );
    public.CheckGatesamulet1( 1 );

    if cmn.IsEventDone( "get_nuts1" ) then
      int.InventoryItemRemove( "inv_ladybag1" );
    end;

    ObjDelete( "gfx_deploy_inv_ladybag1_gatesamulet1_1" );
    ObjDelete( "spr_inv_ladybag1_gatesamulet_1" );

  end;
  
  cmn.AddSubscriber( "get_gatesamulet1_1", get_gatesamulet1_1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_nuts1 () end;
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nuts1" ] =
  {
    type = "get",
    get_obj = "spr_deploy_inv_ladybag1_nuts1",
    room = "int_deploy_inv",
    zz = "deploy_inv_ladybag1",
    zz_gate = "inv_ladybag1"
  };
  --------------------------------------------------------------------------------------------
  local get_nuts1_inv = function ()
  
    int.InventoryItemAdd( "inv_nuts1", "spr_deploy_inv_ladybag1_nuts1" );

    if cmn.IsEventDone( "get_gatesamulet1_1" ) then
      int.InventoryItemRemove( "inv_ladybag1" );
    end;

    ObjDelete( "gfx_deploy_inv_ladybag1_nuts1" );
    ObjDelete( "spr_inv_ladybag1_nuts1" );

  end;
  
  cmn.AddSubscriber( "get_nuts1", get_nuts1_inv );
  --------------------------------------------------------------------------------------------
  -- function use_bagamulet1 () end;
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bagamulet1" ] =
  {
    type = "use",
    use_obj = "inv_bagamulet1",
    use_place = "obj_deploy_inv_ladybag1_use_bagamulet1",
    room = "int_deploy_inv",
    zz = "deploy_inv_ladybag1",
    zz_gate = "inv_ladybag1"
  };
  --------------------------------------------------------------------------------------------
  local use_bagamulet1_inv = function ()
  
    int.InventoryItemRemove( "inv_bagamulet1" );
    ObjSet( "obj_inv_ladybag1_open", { alp = 1 } );
    ObjDelete( "obj_inv_ladybag1_close" );

  end;
  local use_bagamulet1_beg = function ()
  
    ObjDelete( "obj_deploy_inv_ladybag1_use_bagamulet1" );
    ObjDelete( "anm_deploy_inv_ladybag1_bag_click" );
  
  end;
  local use_bagamulet1_end = function ()
  
    ObjDelete( "obj_deploy_inv_ladybag1_close_bag" );
    ObjSet( "obj_deploy_inv_ladybag1_open_bag", { alp = 1 } );
    ObjSet( "spr_deploy_inv_ladybag1_note",  { input = true } );
    ObjSet( "spr_deploy_inv_ladybag1_nuts1", { input = true } );
    ObjSet( "gfx_deploy_inv_ladybag1_nuts1", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bagamulet1", use_bagamulet1_beg, "inv_ladybag1" );
  cmn.AddSubscriber( "use_bagamulet1", use_bagamulet1_inv );
  cmn.AddSubscriber( "use_bagamulet1", use_bagamulet1_end, "inv_ladybag1" );
  cmn.AddSubscriber( "use_bagamulet1_inv", use_bagamulet1_inv );
  cmn.AddSubscriber( "use_bagamulet1_beg", use_bagamulet1_beg, "inv_ladybag1" );
  cmn.AddSubscriber( "use_bagamulet1_end", use_bagamulet1_end, "inv_ladybag1" );
  --------------------------------------------------------------------------------------------
  -- function clk_note1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_note1" ] =
  {
    type = "click",
    clk_obj = "spr_deploy_inv_ladybag1_note",
    room = "int_deploy_inv",
    zz = "deploy_inv_ladybag1",
    zz_gate = "inv_ladybag1"
  };
  --------------------------------------------------------------------------------------------
  local clk_note1_inv = function ()
  
  end;
  local clk_note1_beg = function ()
  
  end;
  local clk_note1_end = function ()

    ObjSet( "spr_deploy_inv_ladybag1_note", { pos_z = 4 } );
    ObjSet( "spr_deploy_inv_ladybag1_gatesamulet1_1", { input = true } );
    ObjSet( "gfx_deploy_inv_ladybag1_gatesamulet1_1", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_note1", clk_note1_beg, "inv_ladybag1" );
  cmn.AddSubscriber( "clk_note1", clk_note1_inv );
  cmn.AddSubscriber( "clk_note1", clk_note1_end, "inv_ladybag1" );
  cmn.AddSubscriber( "clk_note1_inv", clk_note1_inv, "inv_ladybag1" );
  cmn.AddSubscriber( "clk_note1_beg", clk_note1_beg, "inv_ladybag1" );
  cmn.AddSubscriber( "clk_note1_end", clk_note1_end, "inv_ladybag1" );
  --------------------------------------------------------------------------------------------

end;
--------------------------------------------------------------------------------------------
function public.use_bagamulet1 ()

  interface.TutorialHide();

  local item = "inv_bagamulet1";

  if ( cmn.ShowByInv( item, "inv_ladybag1" ) and 
       cmn.IsEventDone( "get_bagamulet1_1" ) and 
       cmn.IsEventDone( "get_bagamulet1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_ladybag1" );

  return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_ladybag1_use_bagamulet1", "deploy_inv_ladybag1" ) and 
           cmn.IsEventDone( "get_bagamulet1_1" ) and 
           cmn.IsEventDone( "get_bagamulet1_2" ) ) then

    cmn.CallEventHandler( "use_bagamulet1_inv" );
    cmn.CallEventHandler( "use_bagamulet1_beg", "inv_ladybag1" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_bagamulet1" );
      cmn.CallEventHandler( "use_bagamulet1_end", "inv_ladybag1" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_ladybag1_bag_click", { alp = 0 } );
    ObjSet( "anm_deploy_inv_ladybag1_use_bagamulets", { alp = 1 } );
    AnimPlay( "anm_deploy_inv_ladybag1_use_bagamulets", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_inv_bag_1_insert" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.get_gatesamulet1_1 ()

  cmn.SetEventDone( "get_gatesamulet1_1" );
  cmn.CallEventHandler( "get_gatesamulet1_1" );
  cmn.GetObjectSfx();
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_nuts1" ) then

    int.DeployInvHide();
    cmn.TutorialShow( "tutorial_hint" );
    cmn.TutorialSetShown( "tutorial_hint" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_nuts1 ()

  cmn.SetEventDone( "get_nuts1" );
  cmn.CallEventHandler( "get_nuts1" );
  cmn.GetObjectSfx();
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_gatesamulet1_1" ) then

    int.DeployInvHide();
    cmn.TutorialShow( "tutorial_hint" );
    cmn.TutorialSetShown( "tutorial_hint" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_note1 ()

  if ( not cmn.IsEventDone( "clk_note1" ) ) then

    cmn.CallEventHandler( "clk_note1_inv" );
    cmn.CallEventHandler( "clk_note1_beg", "inv_ladybag1" );

  end;

  local func_end = function ()

    if ( not cmn.IsEventDone( "clk_note1" ) ) then

      cmn.SetEventDone( "clk_note1" );
      cmn.CallEventHandler( "clk_note1_end", "inv_ladybag1" );

    end;

  end;

  cmn.NoteScale( { "spr_deploy_inv_ladybag1_note" } );
  cmn.WaitAndRun( func_end, 0.3 );

end;
--*********************************************************************************************************************
-- function *** wire1 *** () end;
--*********************************************************************************************************************
function private.init_wire1 ()

  ObjSet( "spr_deploy_inv_wire1_hook",        { event_mdown = private.get_hook1 } );
  ObjSet( "obj_deploy_inv_wire1_use_pliers1", { event_mdown = private.Wire1Click } );
  --------------------------------------------------------------------------------------------
  -- function get_hook1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook1" ] =
  {
    type = "get",
    get_obj = "spr_deploy_inv_wire1_hook",
    room = "int_deploy_inv",
    zz = "deploy_inv_wire1",
    zz_gate = "inv_wire1"
  };
  --------------------------------------------------------------------------------------------
  local get_hook1_inv = function ()
  
    int.InventoryItemAdd( "inv_hook1", "spr_deploy_inv_wire1_hook" );
    int.InventoryItemRemove( "inv_wire1" );
    ObjDelete( "gfx_deploy_inv_wire1_hook" );

  end;

  cmn.AddSubscriber( "get_hook1", get_hook1_inv );
  --------------------------------------------------------------------------------------------
  -- function use_pliers1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers1" ] =
  {
    type = "use",
    use_obj = "inv_pliers1",
    use_place = "obj_deploy_inv_wire1_use_pliers1",
    room = "int_deploy_inv",
    zz = "deploy_inv_wire1",
    zz_gate = "inv_wire1"
  };
  -------------------------------------------------------------------------------------------
  local use_pliers1_inv = function ()

    int.InventoryItemRemove( "inv_pliers1" );
    ObjSet( "inv_wire1", { res = "assets/levels/level1/common_inventory1/inv_wire1/inv/inv_hook1" } );

  end;
  local use_pliers1_beg = function ()

    ObjDelete( "obj_deploy_inv_wire1_use_pliers1" );
    ObjDelete( "anm_deploy_inv_wire1_wire_click" );

  end;
  local use_pliers1_end = function ()

    ObjSet( "spr_deploy_inv_wire1_hook", { alp = 1, input = true } );
    ObjSet( "gfx_deploy_inv_wire1_hook", { active = true } );
    ObjDelete( "anm_deploy_inv_wire1_wire_pliers" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pliers1", use_pliers1_beg, "inv_wire1" );
  cmn.AddSubscriber( "use_pliers1", use_pliers1_inv );
  cmn.AddSubscriber( "use_pliers1", use_pliers1_end, "inv_wire1" );
  cmn.AddSubscriber( "use_pliers1_inv", use_pliers1_inv, "inv_wire1" );
  cmn.AddSubscriber( "use_pliers1_beg", use_pliers1_beg, "inv_wire1" );
  cmn.AddSubscriber( "use_pliers1_end", use_pliers1_end, "inv_wire1" );

end;
--------------------------------------------------------------------------------------------
function private.get_hook1 ()

  cmn.SetEventDone( "get_hook1" );
  cmn.CallEventHandler( "get_hook1" );
  int.DeployInvHide();
  cmn.GetObjectSfx();

end;
--------------------------------------------------------------------------------------------
function public.use_pliers1 ()

  local item = "inv_pliers1";

  if ( cmn.ShowByInv( item, "inv_wire1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_wire1" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_wire1_use_pliers1", "deploy_inv_wire1" ) ) then

    cmn.CallEventHandler( "use_pliers1_inv" );
    cmn.CallEventHandler( "use_pliers1_beg", "inv_wire1" );

    local func_end = function ()
  
      int.Lock( false );
      cmn.SetEventDone( "use_pliers1" );
      cmn.CallEventHandler( "use_pliers1_end", "inv_wire1" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_wire1_wire_pliers", { alp = 1 } );
    AnimPlay( "anm_deploy_inv_wire1_wire_pliers", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_inv_metal" );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** emptyflask1 *** () end;
--*********************************************************************************************************************
function private.init_emptyflask1 ()

  ObjSet( "obj_deploy_inv_emptyflask1_plantreviver1", { event_mdown = private.get_plantreviver1 } );

  --------------------------------------------------------------------------------------------
  -- function get_plantreviver1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plantreviver1" ] =
  {
    type = "get",
    get_obj = "obj_deploy_inv_emptyflask1_plantreviver1",
    room = "int_deploy_inv",
    zz = "deploy_inv_emptyflask1",
    zz_gate = "inv_emptyflask1"
  };
  --------------------------------------------------------------------------------------------
  local get_plantreviver1_inv = function ()
  
    int.InventoryItemAdd( "inv_plantreviver1", "obj_deploy_inv_emptyflask1_plantreviver1" );
    int.InventoryItemRemove( "inv_emptyflask1" );
    ObjDelete( "gfx_deploy_inv_emptyflask1_plantreviver1" );
  
  end;

  cmn.AddSubscriber( "get_plantreviver1", get_plantreviver1_inv );
  --------------------------------------------------------------------------------------------
  -- function use_powder1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_powder1" ] =
  {
    type = "use",
    use_obj = "inv_powder1",
    use_place = "obj_deploy_inv_emptyflask1_use_powder1",
    room = "int_deploy_inv",
    zz = "deploy_inv_emptyflask1",
    zz_gate = "inv_emptyflask1"
  };
  --------------------------------------------------------------------------------------------
  local use_powder1_inv = function ()
  
    int.InventoryItemRemove( "inv_powder1" );

    ObjSet( "inv_emptyflask1_plus_focus2", { alp = 1 } );
    ObjSet( "inv_emptyflask1", { res = "assets/levels/level1/common_inventory1/inv_emptyflask1/inv/inv_plantreviver1" } );
    ObjDelete( "spr_inv_emptyflask1_water" );

  end;
  local use_powder1_beg = function ()
  
    ObjDelete( "obj_deploy_inv_emptyflask1_use_powder1" );
  
  end;
  local use_powder1_end = function ()

    ObjSet( "anm_deploy_inv_emptyflask1_powder",
    {
      frame = 250,
      animfunc = "DoAnim",
      croprect_init = true,
      croprect_x = 450,
      croprect_y = 20,
      croprect_w = 350,
      croprect_h = 450,
    } );
    ObjSet( "obj_deploy_inv_emptyflask1_plantreviver1", { input = true } );
    ObjSet( "gfx_deploy_inv_emptyflask1_plantreviver1", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_powder1", use_powder1_beg, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_powder1", use_powder1_inv );
  cmn.AddSubscriber( "use_powder1", use_powder1_end, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_powder1_inv", use_powder1_inv, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_powder1_beg", use_powder1_beg, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_powder1_end", use_powder1_end, "inv_emptyflask1" );
  --------------------------------------------------------------------------------------------
  -- function use_water1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_water1" ] =
  {
    type = "use",
    use_obj = "inv_water1",
    use_place = "obj_deploy_inv_emptyflask1_use_water1",
    room = "int_deploy_inv",
    zz = "deploy_inv_emptyflask1",
    zz_gate = "inv_emptyflask1"
  };
  --------------------------------------------------------------------------------------------
  local use_water1_inv = function ()
  
    int.InventoryItemRemove( "inv_water1" );

    if ( not cmn.IsEventDone( "get_powder1" ) ) then

      ObjSet( "inv_emptyflask1_plus_focus2", { alp = 0 } );

    end;

    ObjSet( "spr_inv_emptyflask1_water", { alp = 1 } );

  end;
  local use_water1_beg = function ()
  
    ObjDelete( "obj_deploy_inv_emptyflask1_use_water1" );
  
  end;
  local use_water1_end = function ()
  
    ObjDelete( "anm_deploy_inv_emptyflask1_water" );
    ObjSet( "anm_deploy_inv_emptyflask1_powder",      { alp = 1 } );
    ObjSet( "obj_deploy_inv_emptyflask1_use_powder1", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_water1", use_water1_beg, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_water1", use_water1_inv );
  cmn.AddSubscriber( "use_water1", use_water1_end, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_water1_inv", use_water1_inv, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_water1_beg", use_water1_beg, "inv_emptyflask1" );
  cmn.AddSubscriber( "use_water1_end", use_water1_end, "inv_emptyflask1" );

end;
--------------------------------------------------------------------------------------------
function private.get_plantreviver1 ()

  cmn.SetEventDone( "get_plantreviver1" );
  cmn.CallEventHandler( "get_plantreviver1" );
  int.DeployInvHide();
  cmn.GetObjectSfx();

end;
--------------------------------------------------------------------------------------------
function public.use_powder1 ()

  local item = "inv_powder1";

  if ( cmn.ShowByInv( item, "inv_emptyflask1" ) ) and
     ( cmn.IsEventDone( "use_water1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_emptyflask1" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_emptyflask1_use_powder1", "deploy_inv_emptyflask1" ) ) and
         ( cmn.IsEventDone( "use_water1" ) ) then

    cmn.CallEventHandler( "use_powder1_inv" );
    cmn.CallEventHandler( "use_powder1_beg", "inv_emptyflask1" );

    local func_end = function ()
  
      int.Lock( false );
      cmn.SetEventDone( "use_powder1" );
      cmn.CallEventHandler( "use_powder1_end", "inv_emptyflask1" );

    end;

    int.Lock( true );

    AnimPlay( "anm_deploy_inv_emptyflask1_powder", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_dust_empty_flacon" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_water1 ()

  local item = "inv_water1";

  if ( cmn.ShowByInv( item, "inv_emptyflask1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_emptyflask1" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_emptyflask1_use_water1", "deploy_inv_emptyflask1" ) ) then

    cmn.CallEventHandler( "use_water1_inv" );
    cmn.CallEventHandler( "use_water1_beg", "inv_emptyflask1" );

    local func_end = function ()
  
      int.Lock( false );
      cmn.SetEventDone( "use_water1" );
      cmn.CallEventHandler( "use_water1_end", "inv_emptyflask1" );

    end;

    int.Lock( true );

    AnimPlay( "anm_deploy_inv_emptyflask1_water", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_fill_empty_flacon" );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** thread1 *** () end;
--*********************************************************************************************************************
function private.init_thread1 ()

  ObjSet( "obj_deploy_inv_thread1_get_threadhook1", { event_mdown = private.get_threadhook1 } );
  ObjSet( "obj_deploy_inv_thread1_clk_hook1_2",     { event_mdown = private.clk_hook1_2 } );

  --------------------------------------------------------------------------------------------
  -- function get_threadhook1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_threadhook1" ] =
  {
    type = "get",
    get_obj = "obj_deploy_inv_thread1_get_threadhook1",
    room = "int_deploy_inv",
    zz = "deploy_inv_thread1",
    zz_gate = "inv_thread1"
  };
  --------------------------------------------------------------------------------------------
  local get_threadhook1_inv = function ()
  
    int.InventoryItemAdd( "inv_threadhook1", "obj_deploy_inv_thread1_threadhook1" );
    int.InventoryItemRemove( "inv_thread1" );
    ObjDelete( "obj_deploy_inv_thread1_get_threadhook1" );
  
  end;
  
  cmn.AddSubscriber( "get_threadhook1", get_threadhook1_inv );

  --------------------------------------------------------------------------------------------
  -- function use_hook1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook1_2" ] =
  {
    type = "use",
    use_obj = "inv_hook1",
    use_place = "obj_deploy_inv_thread1_use_hook1_2",
    room = "int_deploy_inv",
    zz = "deploy_inv_thread1",
    zz_gate = "inv_thread1"
  };
  --------------------------------------------------------------------------------------------
  local use_hook1_2_inv = function ()
  
    int.InventoryItemRemove( "inv_hook1" );
    ObjSet( "inv_thread1", { res = "assets/levels/level1/common_inventory1/inv_thread1/inv/inv_threadhook1" } );
  end;
  local use_hook1_2_beg = function ()
  
    ObjDelete( "obj_deploy_inv_thread1_use_hook1_2" );
  
  end;
  local use_hook1_2_end = function ()
  
    ObjSet( "spr_deploy_inv_thread1_hook",            { alp = 1, input = true } );
    ObjSet( "obj_deploy_inv_thread1_get_threadhook1", { input = true } );
    ObjSet( "gfx_deploy_inv_thread1_threadhook1",     { active = true } );
    ObjSet( "anm_deploy_inv_thread1_hook",            { frame = 202, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook1_2", use_hook1_2_beg, "inv_thread1" );
  cmn.AddSubscriber( "use_hook1_2", use_hook1_2_inv );
  cmn.AddSubscriber( "use_hook1_2", use_hook1_2_end, "inv_thread1" );
  cmn.AddSubscriber( "use_hook1_2_inv", use_hook1_2_inv, "inv_thread1" );
  cmn.AddSubscriber( "use_hook1_2_beg", use_hook1_2_beg, "inv_thread1" );
  cmn.AddSubscriber( "use_hook1_2_end", use_hook1_2_end, "inv_thread1" );
  --------------------------------------------------------------------------------------------
  -- function clk_hook1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hook1_2" ] =
  {
    type = "click",
    clk_obj = "obj_deploy_inv_thread1_clk_hook1_2",
    room = "int_deploy_inv",
    zz = "deploy_inv_thread1",
    zz_gate = "inv_thread1"
  };
  --------------------------------------------------------------------------------------------
  local clk_hook1_2_inv = function ()
  
  end;
  local clk_hook1_2_beg = function ()
  
    ObjDelete( "obj_deploy_inv_thread1_clk_hook1_2" );
  
  end;
  local clk_hook1_2_end = function ()

    ObjSet( "obj_deploy_inv_thread1_use_hook1_2", { input = true } );
    ObjSet( "anm_deploy_inv_thread1_hook", { alp = 1 } );
    ObjDelete( "anm_deploy_inv_thread1_thread" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hook1_2", clk_hook1_2_beg, "inv_thread1" );
  cmn.AddSubscriber( "clk_hook1_2", clk_hook1_2_inv );
  cmn.AddSubscriber( "clk_hook1_2", clk_hook1_2_end, "inv_thread1" );
  cmn.AddSubscriber( "clk_hook1_2_inv", clk_hook1_2_inv, "inv_thread1" );
  cmn.AddSubscriber( "clk_hook1_2_beg", clk_hook1_2_beg, "inv_thread1" );
  cmn.AddSubscriber( "clk_hook1_2_end", clk_hook1_2_end, "inv_thread1" );
  --------------------------------------------------------------------------------------------

end;
--------------------------------------------------------------------------------------------
function private.get_threadhook1 ()

  cmn.SetEventDone( "get_threadhook1" );
  cmn.CallEventHandler( "get_threadhook1" );
  cmn.GetObjectSfx();
  int.DeployInvHide();  

end;
--------------------------------------------------------------------------------------------
function public.use_hook1_2 ()

  local item = "inv_hook1";

  if ( cmn.ShowByInv( item, "inv_thread1" ) ) and
     ( cmn.IsEventDone( "clk_hook1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_thread1" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_thread1_use_hook1_2", "deploy_inv_thread1" ) ) and
         ( cmn.IsEventDone( "clk_hook1_2" ) ) then

    cmn.CallEventHandler( "use_hook1_2_inv" );
    cmn.CallEventHandler( "use_hook1_2_beg", "inv_thread1" );

    local func_end = function ()
  
      int.Lock( false );
      cmn.SetEventDone( "use_hook1_2" );
      cmn.CallEventHandler( "use_hook1_2_end", "inv_thread1" );

    end;

    int.Lock( true );

    AnimPlay( "anm_deploy_inv_thread1_hook", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clew_inv_metal" );

    return true;

  end;
  
  return false;

end;
--------------------------------------------------------------------------------------------
function private.clk_hook1_2 ()

  cmn.CallEventHandler( "clk_hook1_2_inv" );
  cmn.CallEventHandler( "clk_hook1_2_beg", "inv_thread1" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_hook1_2" );
    cmn.CallEventHandler( "clk_hook1_2_end", "inv_thread1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_deploy_inv_thread1_thread", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clew_inv" );

end;
--*********************************************************************************************************************
-- function *** keypicture1 *** () end;
--*********************************************************************************************************************
function private.init_keypicture1 ()

  ObjSet( "spr_deploy_inv_keypicture1_key", { event_mdown = private.get_key1 } );
  --------------------------------------------------------------------------------------------
  -- function get_key1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_key1" ] =
  {
    type = "get",
    get_obj = "obj_deploy_inv_keypicture1_key_get",
    room = "int_deploy_inv",
    zz = "deploy_inv_keypicture1",
    zz_gate = "inv_keypicture1"
  };
  --------------------------------------------------------------------------------------------
  local get_key1_inv = function ()
  
    int.InventoryItemAdd( "inv_key1", "spr_deploy_inv_keypicture1_key" );
    int.InventoryItemRemove( "inv_keypicture1" );
    ObjDelete( "anm_deploy_inv_keypicture1_finefile" );

  end;
  
  cmn.AddSubscriber( "get_key1", get_key1_inv );
  --------------------------------------------------------------------------------------------
  -- function use_finefile1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_finefile1_1" ] =
  {
    type = "use",
    use_obj = "inv_finefile1",
    use_place = "obj_deploy_inv_keypictire1_use_finefile1_1",
    room = "int_deploy_inv",
    zz = "deploy_inv_keypicture1",
    zz_gate = "inv_keypicture1"
  };
  --------------------------------------------------------------------------------------------
  local use_finefile1_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_finefile1_2" ) ) then

      int.InventoryItemRemove( "inv_finefile1" );

    end;

    ObjSet( "inv_keypicture1_plus_focus2", { alp = 1 } );
    ObjSet( "spr_inv_keypicture1_key", { alp = 1 } );
    ObjDelete( "spr_inv_keypicture1_blank" );

  end;
  local use_finefile1_1_beg = function ()
  
    ObjDelete( "obj_deploy_inv_keypictire1_use_finefile1_1" );
  
  end;
  local use_finefile1_1_end = function ()

    ObjSet( "anm_deploy_inv_keypicture1_finefile", { frame = 178, animfunc = "DoAnim" } );
    ObjSet( "spr_deploy_inv_keypicture1_key", { input = true } );
    ObjSet( "gfx_deploy_inv_keypicture1_key", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_finefile1_1", use_finefile1_1_beg, "inv_keypicture1" );
  cmn.AddSubscriber( "use_finefile1_1", use_finefile1_1_inv );
  cmn.AddSubscriber( "use_finefile1_1", use_finefile1_1_end, "inv_keypicture1" );
  cmn.AddSubscriber( "use_finefile1_1_inv", use_finefile1_1_inv, "inv_keypicture1" );
  cmn.AddSubscriber( "use_finefile1_1_beg", use_finefile1_1_beg, "inv_keypicture1" );
  cmn.AddSubscriber( "use_finefile1_1_end", use_finefile1_1_end, "inv_keypicture1" );
  --------------------------------------------------------------------------------------------
  -- function use_blank1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blank1" ] =
  {
    type = "use",
    use_obj = "inv_blank1",
    use_place = "obj_deploy_inv_keypictire1_use_blank1",
    room = "int_deploy_inv",
    zz = "deploy_inv_keypicture1",
    zz_gate = "inv_keypicture1"
  };
  --------------------------------------------------------------------------------------------
  local use_blank1_inv = function ()
  
    int.InventoryItemRemove( "inv_blank1" );

    if ( not cmn.IsEventDone( "get_finefile1" ) ) then

      ObjSet( "inv_keypicture1_plus_focus2", { alp = 0 } );

    end;

    ObjSet( "spr_inv_keypicture1_blank", { alp = 1 } );

  end;
  local use_blank1_beg = function ()
  
    ObjDelete( "obj_deploy_inv_keypictire1_use_blank1" );
  
  end;
  local use_blank1_end = function ()
  
    ObjSet( "anm_deploy_inv_keypicture1_finefile",        { alp = 1 } );
    ObjSet( "obj_deploy_inv_keypictire1_use_finefile1_1", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blank1", use_blank1_beg, "inv_keypicture1" );
  cmn.AddSubscriber( "use_blank1", use_blank1_inv );
  cmn.AddSubscriber( "use_blank1", use_blank1_end, "inv_keypicture1" );
  cmn.AddSubscriber( "use_blank1_inv", use_blank1_inv, "inv_keypicture1" );
  cmn.AddSubscriber( "use_blank1_beg", use_blank1_beg, "inv_keypicture1" );
  cmn.AddSubscriber( "use_blank1_end", use_blank1_end, "inv_keypicture1" );

end;
--------------------------------------------------------------------------------------------
function private.get_key1 ()

  ObjSet( "spr_deploy_inv_keypicture1_key", { alp = 1 } );
  cmn.SetEventDone( "get_key1" );
  cmn.CallEventHandler( "get_key1" );
  int.DeployInvHide();
  cmn.GetObjectSfx();

end;
--------------------------------------------------------------------------------------------
function public.use_finefile1_1 ()

  local item = "inv_finefile1";

  if ( cmn.ShowByInv( item, "inv_keypicture1" ) ) and
     ( cmn.IsEventDone( "use_blank1" ) ) and
     ( not cmn.IsEventDone( "use_finefile1_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_keypicture1" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_keypictire1_use_finefile1_1", "deploy_inv_keypicture1" ) ) and
         ( cmn.IsEventDone( "use_blank1" ) ) and
         ( not cmn.IsEventDone( "use_finefile1_1" ) ) then

    cmn.CallEventHandler( "use_finefile1_1_inv" );
    cmn.CallEventHandler( "use_finefile1_1_beg", "inv_keypicture1" );

    local func_end = function ()
  
      int.Lock( false );
      cmn.SetEventDone( "use_finefile1_1" );
      cmn.CallEventHandler( "use_finefile1_1_end", "inv_keypicture1" );

    end;

    int.Lock( true );

    AnimPlay( "anm_deploy_inv_keypicture1_finefile", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_stone_inv_screw" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_blank1 ()

  local item = "inv_blank1";

  if ( cmn.ShowByInv( item, "inv_keypicture1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_keypicture1" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_keypictire1_use_blank1", "deploy_inv_keypicture1" ) ) then

    cmn.CallEventHandler( "use_blank1_inv" );
    cmn.CallEventHandler( "use_blank1_beg", "inv_keypicture1" );

    local func_end = function ()
  
      int.Lock( false );
      cmn.SetEventDone( "use_blank1" );
      cmn.CallEventHandler( "use_blank1_end", "inv_keypicture1" );

    end;

    int.Lock( true );

    ObjAnimate( "anm_deploy_inv_keypicture1_finefile", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_stone_inv" );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** CHECK FUNCTIONS *** () end;
--*********************************************************************************************************************
  function public.CheckLetters1 ()

    local count = 0;

    for s = 1, 3 do

      if ( cmn.IsEventDone( "get_letters1_"..s ) ) then

        ObjSet( "spr_inv_letters1_"..s, { alp = 1 } );
        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_letters1_count" );

    else

      ObjSet( "txt_inv_letters1_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckHorseamulet1 ()

    local count = 0;

    for s = 1, 3 do

      if ( cmn.IsEventDone( "get_horseamulet1_"..s ) ) then

        ObjSet( "spr_inv_horseamulet1_"..s, { alp = 1 } );
        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_horseamulet1_count" );

    else

      ObjSet( "txt_inv_horseamulet1_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckRose1 ()

    if ( cmn.IsEventDone( "get_rose1_1" ) ) and
       ( cmn.IsEventDone( "get_rose1_2" ) ) then

      ObjSet( "inv_rose1", { res = "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_rose1_all" } );
      ObjDelete( "txt_inv_rose1_count" );

    elseif ( cmn.IsEventDone( "get_rose1_2" ) ) then

      ObjSet( "inv_rose1", { res = "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_rose1_2" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckCoin1 ()

    if ( cmn.IsEventDone( "get_coin1_1" ) ) and
       ( cmn.IsEventDone( "get_coin1_2" ) ) then

      ObjSet( "inv_coin1", { res = "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_coin1_2" } );
      ObjDelete( "txt_inv_coin1_count" );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckFigurine1 ()

    if ( cmn.IsEventDone( "get_figurine1_1" ) ) and
       ( cmn.IsEventDone( "get_figurine1_2" ) ) then

      ObjSet( "inv_figurine1", { res = "assets/levels/level1/rm_secondfloor1/inv/inv_figurine1_all" } );
      ObjDelete( "txt_inv_figurine1_count" );

    elseif ( cmn.IsEventDone( "get_figurine1_2" ) ) then

      ObjSet( "inv_figurine1", { res = "assets/levels/level1/rm_secondfloor1/inv/inv_figurine1_2" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAuratrace1 ()

    local count = 0;

    for s = 1, 7 do

      if ( cmn.IsEventDone( "get_auratrace1_"..s ) ) then

        count = count + 1;

      end;

    end;

    ObjSet( "inv_soulphial1", { res = "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_"..count } );

    if ( count == 7 ) then

      ObjDelete( "txt_inv_soulphial1_count" );

    else

      ObjSet( "txt_inv_soulphial1_count", { text = count.."/7" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckParchmentamulet1 ()

    local count = 0;

    for s = 1, 3 do

      if ( cmn.IsEventDone( "get_parchmentamulet1_"..s ) ) then

        ObjSet( "spr_inv_parchmentamulet1_"..s, { alp = 1 } );
        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_parchmentamulet1_count" );

    else

      ObjSet( "txt_inv_parchmentamulet1_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckHeart1 ()

    if ( cmn.IsEventDone( "get_heart1_1" ) ) and
       ( cmn.IsEventDone( "get_heart1_2" ) ) then

      ObjSet( "inv_heart1", { res = "assets/levels/level1/rm_secondfloor1/zz_drawerchest1/inv/inv_heart1_2" } );
      ObjDelete( "txt_inv_heart1_count" );

    else 

      ObjSet( "inv_heart1", { res = "assets/levels/level1/rm_secondfloor1/zz_drawerchest1/inv/inv_heart1_1" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckGatesamulet1 ()

    if ( cmn.IsEventDone( "get_gatesamulet1_1" ) ) and
       ( cmn.IsEventDone( "get_gatesamulet1_2" ) ) then

      ObjSet( "inv_gatesamulet1", { res = "assets/levels/level1/common_inventory1/inv_bag1/inv/inv_gatesamulet1_all" } );
      ObjDelete( "txt_inv_gatesamulet1_count" );

    elseif ( cmn.IsEventDone( "get_gatesamulet1_1" ) ) then

      ObjSet( "inv_gatesamulet1", { res = "assets/levels/level1/common_inventory1/inv_bag1/inv/inv_gatesamulet1_1" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckCatamulet1 ()

    if ( cmn.IsEventDone( "get_catamulet1_1" ) ) and
       ( cmn.IsEventDone( "get_catamulet1_2" ) ) then

      ObjSet( "inv_catamulet1", { res = "assets/levels/level1/rm_alley1/zz_animals1/inv/inv_catamulet1_all" } );
      ObjDelete( "txt_inv_catamulet1_count" );

    elseif ( cmn.IsEventDone( "get_catamulet1_2" ) ) then

      ObjSet( "inv_catamulet1", { res = "assets/levels/level1/rm_alley1/zz_animals1/inv/inv_catamulet1_2" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckPortrait1 ()

    if ( cmn.IsEventDone( "get_portrait1_1" ) ) and
       ( cmn.IsEventDone( "get_portrait1_2" ) ) then

      ObjSet( "inv_portrait1", { res = "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_portrait1_all" } );
      ObjDelete( "txt_inv_portrait1_count" );

    elseif ( cmn.IsEventDone( "get_portrait1_2" ) ) then

      ObjSet( "inv_portrait1", { res = "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_portrait1_2" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckToyclothes1 ()

    local count = 0;

    for s = 1, 3 do

      if ( cmn.IsEventDone( "get_toyclothes1_"..s ) ) then

        ObjSet( "spr_inv_toyclothes1_"..s, { alp = 1 } );
        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_toyclothes1_count" );

    else

      ObjSet( "txt_inv_toyclothes1_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckBagamulet1 ()

    if ( cmn.IsEventDone( "get_bagamulet1_1" ) ) and
       ( cmn.IsEventDone( "get_bagamulet1_2" ) ) then

      ObjSet( "inv_bagamulet1", { res = "assets/levels/level1/rm_greywitchgates1/zz_van1/inv/inv_bagamulet1_all" } );
      ObjDelete( "txt_inv_bagamulet1_count" );

    elseif ( cmn.IsEventDone( "get_bagamulet1_2" ) ) then

      ObjSet( "inv_bagamulet1", { res = "assets/levels/level1/rm_greywitchgates1/zz_van1/inv/inv_bagamulet1_2" } );

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Ladybag1Clk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_deploy_inv_ladybag1_use_bagamulet1" );

  end;

  int.Lock( true );
  AnimPlay( "anm_deploy_inv_ladybag1_bag_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_inv_bag_1" );

end;
--*********************************************************************************************************************
function private.Wire1Click ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_deploy_inv_wire1_use_pliers1" );

  end;

  int.Lock( true );
  AnimPlay( "anm_deploy_inv_wire1_wire_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_metal_inv" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.use_soulphial1 ()

  local item = "inv_soulphial1";

  if ( cmn.ApplyObj( item, "obj_greywitchgates1_auratrace_get1", false ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_1" ) and
       not cmn.IsEventDone( "get_auratrace1_1" ) ) then

    rm_greywitchgates1.get_auratrace1_1();
    return true;

  elseif ( cmn.ApplyObj( item, "obj_greywitchgates1_auratrace_get2", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_2" ) and
           not cmn.IsEventDone( "get_auratrace1_2" ) ) then

    rm_greywitchgates1.get_auratrace1_2();
    return true;

  elseif ( cmn.ApplyObj( item, "obj_ruinedsquare1_auratrace_get3", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_3" ) and
           not cmn.IsEventDone( "get_auratrace1_3" ) ) then

    rm_ruinedsquare1.get_auratrace1_3();
    return true;

  elseif ( cmn.ApplyObj( item, "obj_ruinedsquare1_auratrace_get4", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_4" ) and
           not cmn.IsEventDone( "get_auratrace1_4" ) ) then

    rm_ruinedsquare1.get_auratrace1_4();
    return true;

  elseif ( cmn.ApplyObj( item, "gzz_greywitchgates1_bushes1", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_5" ) and
           not cmn.IsEventDone( "get_auratrace1_5" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bushes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bushes1_auratrace_get", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_5" ) and
           not cmn.IsEventDone( "get_auratrace1_5" ) ) then

    rm_greywitchgates1.get_auratrace1_5();
    return true;

  elseif ( cmn.ApplyObj( item, "gzz_greywitchgates1_tree1", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_6" ) and
           not cmn.IsEventDone( "get_auratrace1_6" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree1", nil, { 512, 384 }, true )

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree1_auratrace_get", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_6" ) and
           not cmn.IsEventDone( "get_auratrace1_6" ) ) then

    rm_greywitchgates1.get_auratrace1_6();
    return true;

  elseif ( cmn.ApplyObj( item, "gzz_ruinedsquare1_statue1", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_7" ) and
           not cmn.IsEventDone( "get_auratrace1_7" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue1", nil, { 512, 384 }, true )

    return true;

  elseif ( cmn.ApplyObj( item, "obj_statue1_auratrace_get", false ) and 
           cmn.IsEventDone( "use_mentalmagnifier1_7" ) and
           not cmn.IsEventDone( "get_auratrace1_7" ) ) then

    rm_ruinedsquare1.get_auratrace1_7();
    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************