-- name=ho_hopast2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hopast2" );
  game.relations[ "ho_hopast2" ].exitroom = "rm_shore2";
  private.room_objname = "ho_hopast2";
  private.task_name = "win_hopast2";  
  private.win_hopast2 = {};   
  private.win_hopast2.cutrrent_i_j = {0,0};  
  
  --------------------------------------------------------------------------------------------
  -- function opn_hopast2 () end;
  --------------------------------------------------------------------------------------------
  local opn_hopast2 = function ()

  end;

  cmn.AddSubscriber( "opn_hopast2", opn_hopast2, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hopast2_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_tinamulet2", "spr_hopast2_win" );
      ObjDelete( "gho_shore2_hopast2" );

    end;

  end;
  cmn.AddSubscriber( "win_hopast2", win_hopast2_func );
  --------------------------------------------------------------------------------------------------
  local start_hopast2_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hopast2" );
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;
      
      for i = 1, 3 do
        
        if ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ] > 1 then
          
          for j = 1, ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ]-1 do
            
            ObjDelete( "anm_hopast2_hole_"..i.."_"..j );
            ObjDelete( "obj_hopast2_hole_"..i.."_"..j );      
            ObjDelete( "anm_hopast2_aura_"..i.."_"..j );
            ObjDelete( "obj_hopast2_aura_"..i.."_"..j );      
            ObjDelete( "spr_hopast2_obj_"..i.."_"..j );   
            
          end;
          
        end;
        
      end;  
  
      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].win_ready ) then
      
        ObjSet( "obj_hopast2_obj_win", { alp = 1 } );
        ObjSet( "spr_hopast2_obj_win", { input = true } );
        ObjSet( "txt_hopast2_task", { text = "tsk_hopast2_task_2" } );
        
      end;      

    end;

  end;
  cmn.AddSubscriber( "win_hopast2", start_hopast2_func, "ho_hopast2" );
  --------------------------------------------------------------------------------------------------
  private.win_hopast2.task = { "obj_1", "obj_2", "obj_3", "obj_4", 
               "obj_5", "obj_6", "obj_7", "obj_8", 
               "obj_9", "obj_10", "obj_11", "obj_12", "obj_13", "obj_14", "obj_15" };
  for i = 1, #private.win_hopast2.task do

    ObjSet( "spr_hopast2_"..private.win_hopast2.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hopast2.task[ i ] ); end } );

  end;  

  for i = 1, 3 do
    
    for j = 1, 5 do
   
      ObjSet( "obj_hopast2_hole_"..i.."_"..j, { 
          input = false,
          event_menter = function () cmn.SetCursor( CURSOR_USE ) end, 
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ) end } );     
            
      ObjSet( "obj_hopast2_aura_"..i.."_"..j, { 
          input = false,
          pos_x = ObjGet( "anm_hopast2_aura_"..i.."_"..j ).pos_x,
          pos_y = ObjGet( "anm_hopast2_aura_"..i.."_"..j ).pos_y,          
          event_menter = function () cmn.SetCursor( CURSOR_HAND ) end, 
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ) end, 
          event_mdown = function () private.ClickAura( i, j ) end } );     
            
      ObjSet( "spr_hopast2_obj_"..i.."_"..j, { drag = true, event_dragdrop = function () private.DropPart( i, j ) end } );
        
    end;
  end;  
   
  ObjSet( "spr_hopast2_obj_win", { event_mdown = function () private.GetWin(); end } );    

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hopast2" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hopast2" ) ) then

      cmn.SetEventDone( "opn_hopast2" );
      cmn.CallEventHandler( "opn_hopast2" );
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress = {1,1,1};
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].total = false;

  end;        

  local ho_tasks = {};
  
  local count = 1;
  
  for i = 1, 3 do
  
    for j = 1, 5 do

      interface.TaskPanelTaskAdd( ho_tasks, private.win_hopast2.task[ count ], 1, 0, { { "obj_hopast2_aura_"..i.."_"..j, "obj_hopast2_hole_"..i.."_"..j  } } );
      
      count = count + 1;
    
    end;
    
  end; 
  
  interface.TaskPanelTaskAdd( ho_tasks, "win", 1, 0, { { "spr_hopast2_obj_win" } } );
  
  
  int.TaskPanelShow( ho_tasks );
  private.PanelShow();
  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level2/env/aud_ho_hopast2_env" );
  cmn.PlayAudio( "env", "audio/level2/env/aud_ho_hopast2_env", 1, 1 );
  --cmn.PlayAudio( "mus", "audio/aud_ho_game1_mus", 1, 1 );     

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );
  
  private.InitAura( true );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();  
  
  if (cmn.IsEventDone( private.task_name )) then
        
    rm_shore2.VidShore2Return();
    
  end;

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  private.PanelHide();
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";
  if ( number ) then postfix = "_"..number; end;
  cmn.HoTaskFind( "spr_hopast2_"..name..postfix, name );
  common_impl.PassingHoCheck();  

end;
--*********************************************************************************************************************
function private.PanelShow ( )

  ObjSet( "int_inventory_impl", { input = false } );
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjAttach( "txt_hopast2_task", "int_taskpanel_impl" );    

end;
--*********************************************************************************************************************
function private.PanelHide ( )  
  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );  
  ObjAttach( "txt_hopast2_task", "ho_hopast2" );  
  
end;  
--*********************************************************************************************************************
function private.ChangeAura ( number )  
  
  --убираем старую
  local aura_progres = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ number ];
  
  local current_aura = "anm_hopast2_aura_"..number.."_"..aura_progres;
  local obj_current_aura = "obj_hopast2_aura_"..number.."_"..aura_progres;  
  local obj_current_hole = "obj_hopast2_hole_"..number.."_"..aura_progres;    
  
  ObjSet( current_aura, { alp = 0 } );  
  ObjSet( obj_current_aura, { input = false } );    
  ObjSet( obj_current_hole, { input = false } );      
    
  -- появляем новую
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ number ] = 
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ number ] + 1;

  aura_progres = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ number ];    
  
  local next_aura = "anm_hopast2_aura_"..number.."_"..aura_progres;
  local obj_next_aura = "obj_hopast2_aura_"..number.."_"..aura_progres;
  local obj_next_hole = "obj_hopast2_hole_"..number.."_"..aura_progres;  
  
  -- если не последняя из 5
  if ( ObjGet( next_aura ) ) then
  
    ObjSet( next_aura, { alp = 1 } );  
    ObjSet( obj_next_aura, { input = true, pos_x = ObjGet( next_aura ).pos_x, pos_y = ObjGet( next_aura ).pos_y } );  
    ObjSet( obj_next_hole, { input = true } );      

  end;  
  
end;  
--*********************************************************************************************************************
function private.ClickAura ( i, j )  
  
  private.win_hopast2.cutrrent_i_j[ 1 ] = i;
  private.win_hopast2.cutrrent_i_j[ 2 ] = j;
    
  local aura_progres = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ]; 
  local current_aura = "anm_hopast2_aura_"..i.."_"..j;  
  local obj_current_aura = "obj_hopast2_aura_"..i.."_"..j;   
  local obj_current_hole = "obj_hopast2_hole_"..i.."_"..j;     
  --вырубаем кликнутую
  ObjSet( current_aura, { alp = 0, frame = 0, playing = false } );
  ObjSet( obj_current_aura, { input = false } );
  ObjSet( obj_current_hole, { input = false } );  
  
  --врубаем анимацию клика
  ObjSet( "anm_hopast2_aura_click", { 
    frame = 0,
    alp = 1, 
    pos_x = ObjGet( "anm_hopast2_aura_"..i.."_"..j ).pos_x, 
    pos_y = ObjGet( "anm_hopast2_aura_"..i.."_"..j ).pos_y} );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_hopast2_click" );
  AnimPlay( "anm_hopast2_aura_click", "DoAnim", "" );
  
  --начинаем таскать объект
  ObjStartDrag( "spr_hopast2_obj_"..i.."_"..j );  
  
end;  
--*********************************************************************************************************************
function private.DropPart ( i, j )  
  
  cmn.SetCursor( CURSOR_DEFAULT );
  
  --куда бросили
  if ( cmn.ApplyObj("spr_hopast2_obj_"..i.."_"..j, "obj_hopast2_hole_"..i.."_"..j, false) ) then
    
    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_hopast2_insert" );
    --вырубаем дырку
    local current_hole = "anm_hopast2_hole_"..i.."_"..j;  
    local func_end = function ()

      ObjDelete( "anm_hopast2_hole_"..i.."_"..j );
      ObjDelete( "obj_hopast2_hole_"..i.."_"..j );      
      ObjDelete( "anm_hopast2_aura_"..i.."_"..j );
      ObjDelete( "obj_hopast2_aura_"..i.."_"..j );      
      ObjDelete( "spr_hopast2_obj_"..i.."_"..j );  

      --показываем следующую ауру
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ] = 
        ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ] + 1;    
      
      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ] < 6 ) then
      
        private.InitAura( false );
        
      else
        
        --проверяем что все три цепочки закончились
        private.CheckHO();
        
      end;
      
      --cmn.HoTaskFind( "spr_hopast2_"..i.."_"..j, name );
      --common_impl.PassingHoCheck();        
      
    end;
    
    ObjSet( "anm_hopast2_hole_"..i.."_"..j, { alp = 0, playing = false, frame = 0 } );
    ObjSet( "anm_hopast2_part_disappear", { 
      alp = 1,
      frame = 0,
      pos_x = ObjGet( current_hole ).pos_x, 
      pos_y = ObjGet( current_hole ).pos_y } );
    AnimPlay( "anm_hopast2_part_disappear", "DoAnim", func_end );   
    
  else

    --не попали куда надо
    local current_aura = "anm_hopast2_aura_"..i.."_"..j;  
    local obj_current_aura = "obj_hopast2_aura_"..i.."_"..j;   
    
    --врубаем анимацию ауры обратно
    private.InitAura(false);
  
  end;
  
  
end;  
--*********************************************************************************************************************
function private.InitAura ( open ) 
 
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_hopast2_appear" );
  if ( open ) then

      DbgTrace( "InitAura open" );
      
  
    
    for i = 1, 3 do   
      
      local aura_progres = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ]; 
      
      if (aura_progres < 6) then
        
            int.Lock( true ); 
            
        local current_aura = "anm_hopast2_aura_"..i.."_"..aura_progres;  
        local obj_current_aura = "obj_hopast2_aura_"..i.."_"..aura_progres;   
        local obj_current_hole = "obj_hopast2_hole_"..i.."_"..aura_progres;          
        
        local func_end = function ()
          
          int.Lock( false );
          ObjSet( current_aura, { alp = 1, frame = 0, playing = true } );
          ObjSet( obj_current_aura, { input = true } ); 
          ObjSet( obj_current_hole, { input = true } );                 
          ObjSet( "anm_hopast2_aura_"..i.."_appear", { alp = 0, frame = 0, playing = false } ); 
          
        end;        
        
        ObjSet( "anm_hopast2_aura_"..i.."_appear", { alp = 1, frame = 0, pos_x = ObjGet( current_aura ).pos_x, pos_y = ObjGet( current_aura ).pos_y } );
        AnimPlay( "anm_hopast2_aura_"..i.."_appear", "DoAnim", func_end );
        
      end;
      
    end;
      
  else
    
    int.Lock( true );    
      
    local i = private.win_hopast2.cutrrent_i_j[ 1 ];
    
    local aura_progres = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ]; 
    local current_aura = "anm_hopast2_aura_"..i.."_"..aura_progres;  
    local obj_current_aura = "obj_hopast2_aura_"..i.."_"..aura_progres;  
    local obj_current_hole = "obj_hopast2_hole_"..i.."_"..aura_progres;              
    
    local func_end = function ()
      
      int.Lock( false );
      ObjSet( current_aura, { alp = 1, frame = 0, playing = true } );
      ObjSet( obj_current_aura, { input = true } ); 
      ObjSet( obj_current_hole, { input = true } );             
      ObjSet( "anm_hopast2_aura_"..i.."_appear", { alp = 0, frame = 0, playing = false } ); 
      
      private.win_hopast2.cutrrent_i_j[ 1 ] = 0;
      private.win_hopast2.cutrrent_i_j[ 2 ] = 0;
      
    end;

    ObjSet( "anm_hopast2_aura_"..i.."_appear", { alp = 1, frame = 0, pos_x = ObjGet( current_aura ).pos_x, pos_y = ObjGet( current_aura ).pos_y } );
    AnimPlay( "anm_hopast2_aura_"..i.."_appear", "DoAnim", func_end );    
    
  end;
  
end;  
--*********************************************************************************************************************
function private.CheckHO ()
  
  local is_win = true;
  
  for i = 1, 3 do   
  
    local aura_progres = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].aura_progress[ i ]; 
    
    if ( aura_progres < 6 ) then 
      
      is_win = false;
      break;
      
    end;
    
  end;
  
  if ( is_win ) then 

    local func_end = function ()
      
      int.Lock( false );
      ObjSet( "obj_hopast2_obj_win", { alp = 1 } );
      ObjSet( "spr_hopast2_obj_win", { input = true } );
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].win_ready = true;
      ObjSet( "txt_hopast2_task", { text = "tsk_hopast2_task_2" } );
      
    end;    
    
    int.Lock( true );    
    ObjAnimate( "obj_hopast2_obj_win", "alp", 0, 0, func_end, 
    {
      0.0, 0, 0,
      0.5, 0, 1
    } );
    
  else
    
    int.Lock( false );
    
  end;
  
end;
--*********************************************************************************************************************
function private.GetWin( )

  cmn.HoTaskFind( "spr_hopast2_obj_win", "win" );    
  common_impl.PassingHoCheck();  
  int.Lock( true );
  MsgSend( Event_DialogHo_Show, {} );  
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************