-- name=ho_hoskeleton2_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hoskeleton2_rpl" );
  game.relations[ "ho_hoskeleton2_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_hoskeleton2_rpl";
  private.task_name = "win_hoskeleton2_rpl";  
  private.win_hoskeleton2_rpl = {};      

  --------------------------------------------------------------------------------------------
  -- function opn_hoskeleton2_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_hoskeleton2_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_hoskeleton2_rpl", opn_hoskeleton2_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hoskeleton2_rpl_func = function ()

  end;
  cmn.AddSubscriber( "win_hoskeleton2_rpl", win_hoskeleton2_rpl_func );
  --------------------------------------------------------------------------------------------------
  local start_hoskeleton2_rpl_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hoskeleton2_rpl", start_hoskeleton2_rpl_func );
  --------------------------------------------------------------------------------------------------
  private.win_hoskeleton2_rpl.task = { "item_1", "item_2", "item_3", "item_4", 
               "item_5", "item_6", "item_7", "item_8", 
               "item_9", "item_10", "item_11", "item_12" };
  for i = 1, #private.win_hoskeleton2_rpl.task do

    ObjSet( "spr_hoskeleton2_rpl_"..private.win_hoskeleton2_rpl.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hoskeleton2_rpl.task[ i ] ); end } );

  end;
  
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, true );     
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hoskeleton2_rpl" );

  end;

  if ( not cmn.IsEventDone( "opn_hoskeleton2_rpl" ) ) then

      cmn.SetEventDone( "opn_hoskeleton2_rpl" );
      cmn.CallEventHandler( "opn_hoskeleton2_rpl" );
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = 12;

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hoskeleton2_rpl.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hoskeleton2_rpl.task[ i ], 1, 0, { { "spr_hoskeleton2_rpl_"..private.win_hoskeleton2_rpl.task[ i ]  } } );
    
  end;
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  
  cmn.StopAllMus();
  --cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1 );  
  cmn.StopAllEnv( "audio/level2/env/aud_ho_hoskeleton2_env" );
  cmn.PlayAudio( "env", "audio/level2/env/aud_ho_hoskeleton2_env", 1, 1 );  

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.StopMusEnv( false );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();  

end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "obj_int_taskpanel", { alp = 1, input = true } );  
  ObjSet( "txt_int_taskpanel", { alp = 1 } );  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hoskeleton2_rpl_panel", "ho_hoskeleton2_rpl" );
  --cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 0.5 );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function public.ResetHO ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].start = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = 12;

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";
  if ( number ) then postfix = "_"..number; end;
  cmn.HoTaskFind( "spr_hoskeleton2_rpl_"..name..postfix, name );
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count - 1;
  ObjSet( "txt_hoskeleton2_rpl_task_num", { text = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count } );

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hoskeleton2_rpl_panel", "int_taskpanel_impl" );
  ObjSet( "txt_hoskeleton2_rpl_task_num", { text = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************