-- name=ho_hotreasury3_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  
  room.Define( "ho_hotreasury3_rpl" );
  game.relations[ "ho_hotreasury3_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_hotreasury3_rpl";

  private.task_name = "win_hotreasury3_rpl";  
  private.win_hotreasury3_rpl = {};  

  --------------------------------------------------------------------------------------------
  -- function opn_hotreasury3_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_hotreasury3_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_hotreasury3_rpl", opn_hotreasury3_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hotreasury3_rpl_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then 
    
    else
      
      local count_keys = 0;
      
      for i = 1, 3 do
        
        local count_slots = 0;
        
        for j = 1, 5 do

          if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items[i][j] == 1 ) then
            
            count_slots = count_slots + 1;
            
            ObjSet( "spr_hotreasury3_rpl_symbols_obj_"..i.."_"..j, { alp = 1 } );
            
          end;
          
        end;  

        if (count_slots == 5) then
  
          ObjDelete( "spr_hotreasury3_rpl_symbols_"..i.."_box_"..i.."_cap" ); 
          ObjSet( "spr_hotreasury3_rpl_symbol_"..i.."_key", { input = true } );    
          ObjSet( "obj_hotreasury3_rpl_key_"..i, { input = true } );     
          
        end;        

        if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys[i] == 1 ) then
          
          count_keys = count_keys + 1;
          
          ObjDelete( "spr_hotreasury3_rpl_symbol_"..i.."_key" );
          ObjSet( "anm_hotreasury3_rpl_anims_key_"..i, { alp = 1 } );
          ObjDelete( "obj_hotreasury3_rpl_key_"..i );
          --ObjSet( "повернутый ключ"..i, { alp = 1 } );
          
        end;
        
      end;   
 
      if (count_keys == 3) then

        ObjSet( "anm_hotreasury3_rpl_anims_opn_box_end", { alp = 1 } );
        ObjDelete( "anm_hotreasury3_rpl_anims_opn_box" );    
        ObjDelete( "spr_hotreasury3_rpl_anims_close_box" );
        
        ObjSet( "spr_hotreasury3_rpl_papers", { alp = 1, input = true } );  
        
      end;        
          
    end;

  end;
  cmn.AddSubscriber( "win_hotreasury3_rpl", win_hotreasury3_rpl_func );
  --------------------------------------------------------------------------------------------------
  local start_hotreasury3_rpl_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hotreasury3_rpl", start_hotreasury3_rpl_func, "ho_hotreasury3_rpl" );
  --------------------------------------------------------------------------------------------------
  private.win_hotreasury3_rpl.task = { { "obj_1_1", "obj_1_2", "obj_1_3", "obj_1_4", "obj_1_5" },
                                   { "obj_2_1", "obj_2_2", "obj_2_3", "obj_2_4", "obj_2_5" },
                                   { "obj_3_1", "obj_3_2", "obj_3_3", "obj_3_4", "obj_3_5" } };

  for i = 1, 3 do
    for j = 1, 5 do

      ObjSet( "spr_hotreasury3_rpl_"..private.win_hotreasury3_rpl.task[ i ][ j ], { event_mdown = function () private.CompleteTask( private.win_hotreasury3_rpl.task[ i ][ j ], i, j ); end } );

    end;
  end;

  for i = 1, 3 do

    ObjSet( "spr_hotreasury3_rpl_symbol_"..i.."_key", { event_mdown = function () private.GetKey( i ); end, event_dragdrop = function () private.UseKey ( i ); end } );

  end;
    
    ObjSet( "spr_hotreasury3_rpl_papers", { event_mdown = function () private.GetPapers(); end } );    
    

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.StopMusEnv( false );

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.ResetHO ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].start = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys      = { 0, 0, 0 };
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys_slot = { 0, 0, 0 };
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items = { { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 } };


end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, true );     
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hotreasury3_rpl" );

  end;

  if ( not cmn.IsEventDone( "opn_hotreasury3_rpl" ) ) then

      cmn.SetEventDone( "opn_hotreasury3_rpl" );
      cmn.CallEventHandler( "opn_hotreasury3_rpl" );
    
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys      = { 0, 0, 0 };
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys_slot = { 0, 0, 0 };
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items = { { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 } };
    

  end;        

  local ho_tasks = {};
  
  for i = 1, 3 do
    for j = 1, 5 do

      interface.TaskPanelTaskAdd( ho_tasks, private.win_hotreasury3_rpl.task[ i ][ j ], 1, 0, { { "spr_hotreasury3_rpl_"..private.win_hotreasury3_rpl.task[ i ][ j ]  } } );
    
    end;
  end;
  
  for i = 1, 3 do

    interface.TaskPanelTaskAdd( ho_tasks, "key_"..i,  1, 0, { { "spr_hotreasury3_rpl_symbol_"..i.."_key", "obj_hotreasury3_rpl_key_"..i } } );
    
  end; 
  
  interface.TaskPanelTaskAdd( ho_tasks, "papers",  1, 0, { { "spr_hotreasury3_rpl_papers" } } );  
  
  
  int.TaskPanelShow( ho_tasks );
  private.PanelShow();
  cmn.StopAllMus();

  cmn.StopAllEnv( "audio/level3/env/aud_rm_secretroom3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_secretroom3_env", 1 );

end;
--*********************************************************************************************************************
function public.Close ()

  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();
  private.PanelHide();  
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, i, j )

  if (name == "obj_1_3") then
    ObjSet( "spr_hotreasury3_rpl_obj_1_3", { res = "assets/levels/level3/ho_hotreasury3/anims/obj_1_3" } );
    ObjSet( "anm_hotreasury3_rpl_obj_1_3_obj_1_3", { alp = 0 } );
  elseif ( name == "obj_2_2") then
    ObjSet( "spr_hotreasury3_rpl_obj_2_2", { res = "assets/levels/level3/ho_hotreasury3/anims/obj_2_2" } ); 
    ObjSet( "anm_hotreasury3_rpl_obj_2_2_obj_2_2", { alp = 0 } );   
  end;
  
  
  cmn.HoTaskFind( "spr_hotreasury3_rpl_"..name, name );
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items[ i ][ j ] = 1;  

  local count_slots = 0;  
  
  local func_end = function ()

    private.CompleteTaskEnd( count_slots, i );

  end;      
  
  for j = 1, 5 do

    if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items[ i ][ j ] == 1 ) then
      
      count_slots = count_slots + 1;
      
    end;
    
  end;  
  
  ObjAnimate( "spr_hotreasury3_rpl_symbols_obj_"..i.."_"..j, "alp", 0, 0, func_end, 
  {
    0.0, 0, 0,
    0.5, 0, 1,
  } );  

end;
--*********************************************************************************************************************
function private.CompleteTaskEnd ( count_slots, i )
  
  if (count_slots == 5) then

    ObjDelete( "spr_hotreasury3_rpl_symbols_"..i.."_box_"..i.."_cap" ); 
    ObjSet( "spr_hotreasury3_rpl_symbol_"..i.."_key", { input = true } );   
    ObjSet( "obj_hotreasury3_rpl_key_"..i, { input = true} );    
    
  end;       
  
end;
--*********************************************************************************************************************
function private.PanelShow ( )

  ObjSet( "obj_hotreasury3_rpl_taskpanel", { alp = 1 } );
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );

  ObjAttach( "obj_hotreasury3_rpl_taskpanel","int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.PanelHide ( )  
  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );  
  ObjAttach( "obj_hotreasury3_rpl_taskpanel","ho_hotreasury3_rpl" );  
  
end;  
--*********************************************************************************************************************
function private.GetKey ( num )

  cmn.GetObjectSfx();
  ObjAttach( "spr_hotreasury3_rpl_symbol_"..num.."_key", "int_taskpanel_impl" );
  --ObjSet( "spr_hotreasury3_rpl_symbol_"..num, { res = "assets/levels/level1/ho_hotreasury3_rpl/layers/amulets/amulet_"..num, pos_z = 5 } );
  --ObjSet( "spr_hotreasury3_rpl_symbol_"..num.."_shadow", { alp = 0 } );
  --ObjSet( "spr_hotreasury3_rpl_symbol_"..num, { alp = 0 } );  

end;
--*********************************************************************************************************************
function private.UseKey ( num )

  local item = "spr_hotreasury3_rpl_symbol_"..num.."_key";
  local bool = true;
  SetCursor( CURSOR_DEFAULT );

  if ( ObjIntersect( item, "obj_hotreasury3_rpl_key_"..num ) ) then

      bool = false;
      int.Lock( true );
      parent_obj = "ho_hotreasury3_rpl";

      local func_end = function ()

          private.UseKeyEnd( num, num );

      end;          

      ObjDelete( item );    
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hotreasury_key" );
      ObjAnimate( "anm_hotreasury3_rpl_anims_key_"..num, "alp", 0, 0, func_end, 
      { 
        0.0,  0,  0,
        0.3,  0,  1,
      } );

      --ObjAnimate( "obj_hotreasury3_rpl_symbol_"..num, "pos_y", 0, 0, func_end, 
      --{ 
      --  0.0,  0,  20,
      --  0.3,  0,  20,
      --  0.8,  1,  150
      --} );

  end;

  if ( bool ) then

    ObjAttach( item, "obj_hotreasury3_rpl_symbol_"..num );
    --ObjSet( item, { res = "assets/levels/level1/ho_hotreasury3_rpl/layers/amulet_"..num, pos_z = 0 } );
    --ObjSet( item.."_shadow", { alp = 1 } );      
      cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.UseKeyEnd( num1, num2 )

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys[ num1 ] = 1;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys_slot[ num2 ] = 1;

  cmn.HoTaskFind( "spr_hotreasury3_rpl_symbol_"..num1.."_key", "key_"..num1 );
    
  int.Lock( false ); 

  ObjDelete( "obj_hotreasury3_rpl_symbol_"..num2 );
  ObjDelete( "obj_hotreasury3_rpl_key_"..num2 );
  
  local is_win = true;
  
  for i = 1, 3 do

    if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].keys[ i ] ~= 1 ) then

      is_win = false;
      
    end;
    
  end;  
  
  if (is_win) then    

    local func_end = function ()
      
      ObjSet( "anm_hotreasury3_rpl_anims_opn_box_end", { alp = 1 } );
      ObjSet( "anm_hotreasury3_rpl_anims_key_1", { alp = 1 } );
      ObjSet( "anm_hotreasury3_rpl_anims_key_2", { alp = 1 } );
      ObjSet( "anm_hotreasury3_rpl_anims_key_3", { alp = 1 } );         
      ObjDelete( "anm_hotreasury3_rpl_anims_opn_box" );
      ObjSet( "spr_hotreasury3_rpl_papers", { alp = 1, input = true } );

    end;      

    ObjSet( "anm_hotreasury3_rpl_anims_key_1", { alp = 0 } );
    ObjSet( "anm_hotreasury3_rpl_anims_key_2", { alp = 0 } );
    ObjSet( "anm_hotreasury3_rpl_anims_key_3", { alp = 0 } );    
    
    ObjSet( "anm_hotreasury3_rpl_anims_opn_box", { alp = 1 } );
    ObjDelete( "spr_hotreasury3_rpl_anims_close_box" ); 
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hotreasury_open" );
    AnimPlay( "anm_hotreasury3_rpl_anims_opn_box", "DoAnim", func_end );
    
  end;

end;
--*********************************************************************************************************************
function private.GetPapers( )

  ObjDelete( "spr_hotreasury3_rpl_papers" );
  int.Lock( true );
  MsgSend( Event_DialogHo_Show, {} );      
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************