-- name=ho_hocardindex3
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  
  room.Define( "ho_hocardindex3" );
  game.relations[ "ho_hocardindex3" ].exitroom = "rm_mortuary3";
  private.room_objname = "ho_hocardindex3";

  private.task_name = "win_hocardindex3";  
  private.win_hocardindex3 = {};  
  private.win_hocardindex3.parent = "";

  --------------------------------------------------------------------------------------------
  -- function opn_hocardindex3 () end;
  --------------------------------------------------------------------------------------------
  local opn_hocardindex3 = function ()

  end;

  cmn.AddSubscriber( "opn_hocardindex3", opn_hocardindex3, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hocardindex3_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_card3", "spr_hocardindex3_win" );
      ObjDelete( "gho_mortuary3_hocardindex3" );

      ObjSet( "obj_int_taskpanel", { alp = 1 } );  
   
    else
   
      for i = 1, 4 do
        
        if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].amulet[ i ] == 1 ) then
          
          ObjDelete( "spr_hocardindex3_objects_amulet_"..i );          
          ObjDelete( "obj_hocardindex3_use_amulet_"..i );
          
          ObjSet( "obj_hocardindex3_objects_open_"..i, { alp = 1, input = true } );
          ObjSet( "spr_hocardindex3_objects_amulet_"..i+1, { input = true } );  
          ObjSet( "obj_hocardindex3_use_amulet_"..i+1, { input = true } );  
          
          if (i == 3 and 
              ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set == 12) then
            
            ObjSet( "txt_hocardindex3_task_battery", { alp = 1 } );
            
          elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set == 12 ) then            
            
            ObjSet( "txt_hocardindex3_task_battery", { alp = 0 } );            
            ObjSet( "txt_hocardindex3_task_"..i+1, { alp = 1 } );                      
            
          end;
          
          if ( i == 4) then

            ObjSet( "spr_hocardindex3_batt_inside", { alp = 1 } );

          end;          

                  
        end;    
    
      end;             
    
    end;

  end;
  cmn.AddSubscriber( "win_hocardindex3", win_hocardindex3_func );
  --------------------------------------------------------------------------------------------------
  local start_hocardindex3_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hocardindex3" );
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hocardindex3", start_hocardindex3_func, "ho_hocardindex3" );
  --------------------------------------------------------------------------------------------------
  private.win_hocardindex3.task = { "obj_1", "obj_2", "obj_3", "obj_4", "obj_5", "obj_6", "obj_7", "obj_8", "obj_9", "obj_10", "obj_11", "obj_12" };

  for i = 1, #private.win_hocardindex3.task do

    ObjSet( "spr_hocardindex3_"..private.win_hocardindex3.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hocardindex3.task[ i ] ); end, input = false } );

  end; 
    
  for i = 1, 4 do

    ObjSet( "spr_hocardindex3_objects_amulet_"..i, { event_mdown = function () private.GetAmulet( i ); end, event_dragdrop = function () private.UseAmulet ( i ); end } );

  end;    
    
  ObjSet( "spr_hocardindex3_objects_amulet_5", { event_mdown = function () private.GetCard(); end } ); 

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hocardindex3" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hocardindex3" ) ) then

      cmn.SetEventDone( "opn_hocardindex3" );
      cmn.CallEventHandler( "opn_hocardindex3" );
      
      ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set = 0;
      ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].amulet = {0,0,0,0};      

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hocardindex3.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hocardindex3.task[ i ], 1, 0, { { "spr_hocardindex3_"..private.win_hocardindex3.task[ i ]  } } );
    
  end; 

  interface.TaskPanelTaskAdd( ho_tasks, "amulet_1", 1, 0, { { "spr_hocardindex3_objects_amulet_1", "obj_hocardindex3_use_amulet_1"  } } ); 
  interface.TaskPanelTaskAdd( ho_tasks, "amulet_2", 1, 0, { { "spr_hocardindex3_objects_amulet_2", "obj_hocardindex3_use_amulet_2"  } } );    
  interface.TaskPanelTaskAdd( ho_tasks, "amulet_3", 1, 0, { { "spr_hocardindex3_objects_amulet_3", "obj_hocardindex3_use_amulet_3"  } } );    
  interface.TaskPanelTaskAdd( ho_tasks, "amulet_4", 1, 0, { { "spr_hocardindex3_objects_amulet_4", "obj_hocardindex3_use_amulet_4"  } } );      
  
  interface.TaskPanelTaskAdd( ho_tasks, "card", 1, 0, { { "spr_hocardindex3_objects_amulet_5"  } } );  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  
  private.ClearTasks();

  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level3/env/aud_rm_mortuary3_env" );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_mortuary3_env", 1, 1 ); 

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );    
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hocardindex3_panel","ho_hocardindex3" );
  
  for i = 1,#private.win_hocardindex3.task do 

     local obj = "obj_"..i;
     ObjDelete( obj );

  end;     
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )
  
  if (ObjGet("spr_hocardindex3_"..name).alp > 0.8) then
  
    cmn.HoTaskFind( "spr_hocardindex3_"..name, name );
    
    for i = 1,#private.win_hocardindex3.task do

        if ( private.win_hocardindex3.task[i] == name ) then 

            local object_name = "obj_"..i; 
            --DbgTrace( object_name );
            local collect_name  = "pfx_hocardindex3_collect_"..object_name.."_effect";
            ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].task_check[ i ] = 1;
            ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set = ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set + 1;
            ObjCreate( collect_name, "partsys" );

            if  ( cmn.IsEventDone( "win_hocardindex3" ) ) then

                --int.Lock( false );

            end;

            ObjSet( collect_name,{
              res    = "assets/interface/resources/effects_ho_hint",
              pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
              active = 1, visible = 1, input = 0
            } );

            ObjAttach( collect_name, "obj_hocardindex3_panel" );
            ObjSet( collect_name, { blendmode = 2, scale_x = 0.8, scale_y = 0.8 } );

            local func_end = function () private.AnimInv( i ); end;
              
            int.Lock( true );            
              
            ObjAnimate( object_name, 8,0,0, func_end,{ 
                0.0, 0, 1.0,
                0.5, 0, 0.0
            } );
              
        end;

    end;  
    int.Lock( true );            
    common_impl.PassingHoCheck();
    
    if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set == 12 ) then
      
      if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].amulet[ 4 ] == 1 ) then
        
        ObjSet( "txt_hocardindex3_task_5", { alp = 1} );        
        
      else
        
        ObjSet( "txt_hocardindex3_task_battery", { alp = 1} );
        
      end;      

    end;    
  
  end;

end;
--*********************************************************************************************************************
function private.ClearTasks ()

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

  for i = 1, #ho_found, 1 do
      ObjDelete( ho_found[ i ][ "object" ] );
  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hocardindex3_panel" , "spr_int_taskpanel" );
  
  if ( not ng_global.progress[ ng_global.currentprogress ]["win_hocardindex3"].task_check ) then

    ng_global.progress[ng_global.currentprogress]["win_hocardindex3"].task_check = { 0,0,0,0,0,0,0,0,0,0,0,0,0 };

  end;

  local posx = -175;
  local tmp = 0;

  ObjSet( "obj_hocardindex3_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 560, croprect_h = 400 } );

  for i = 1,#private.win_hocardindex3.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress[ng_global.currentprogress]["win_hocardindex3"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_hocardindex3_panel" );
        ObjSet( obj, { pos_x = posx, pos_y = 24, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_hocardindex3_"..private.win_hocardindex3.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level3/ho_hocardindex3/layers/inv/"..private.win_hocardindex3.task[i].."_inv", scale_x = 0.8, scale_y = 0.8 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

         posx = posx + 95;

--         if ( tmp == 0 ) then
--
--          ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set = true;
--          ObjSet( "obj_hocardindex3_win", { alp = 1, input = true } );
--          ObjSet( "spr_hocardindex3_win_bottle", { input = true } );
--
--        end;

     else

     end;

  end;

end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      local activate = true;
      
      if ( i == 8 or i == 9 ) then
        
        if ( not ObjGet( "obj_hocardindex3_objects_open_1" ).input ) then
          
          activate = false;                
          
        end;              
        
      elseif ( i == 10 or i == 11 ) then
        
        if ( not ObjGet( "obj_hocardindex3_objects_open_2" ).input ) then
          
          activate = false;                
          
        end;  
        
      elseif ( i == 12 ) then
        
        if ( not ObjGet( "obj_hocardindex3_objects_open_3" ).input ) then
          
          activate = false;                
          
        end;                
        
      end;     

      if ( activate ) then       
 
        ObjSet( "spr_hocardindex3_obj_"..i, { alp = 1, input = 1 } );                            
        
      end;             
      
      --ObjSet( "spr_hocardindex3_"..private.win_hocardindex3.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;
  local panel_sound = false;

      for i = tmp,#private.win_hocardindex3.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].task_check[ i ] ~= 1 then

              if not panel_sound then
                --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_fakel_click" );
                panel_sound = true;
              end;

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-95
              });

              if ObjGet( "obj_"..i ).pos_x-95 == 205 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_hocardindex3.task do

       local item = "obj_"..i;

       if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;         

          if ( tmp < 6 ) then            
            
            local activate = true;
            
            if ( i == 8 or i == 9 ) then
              
              if ( not ObjGet( "obj_hocardindex3_objects_open_1" ).input ) then
                
                activate = false;                
                
              end;              
              
            elseif ( i == 10 or i == 11 ) then
              
              if ( not ObjGet( "obj_hocardindex3_objects_open_2" ).input ) then
                
                activate = false;                
                
              end;  
              
            elseif ( i == 12 ) then
              
              if ( not ObjGet( "obj_hocardindex3_objects_open_3" ).input ) then
                
                activate = false;                
                
              end;                
              
            end;     
     
            if ( activate ) then              
       
              ObjSet( "spr_hocardindex3_obj_"..i, { alp = 1, input = 1 } );                            
              
            end;       

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_hocardindex3", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************
function private.GetAmulet ( num )

  local item = "spr_hocardindex3_objects_amulet_"..num;
  
  private.win_hocardindex3.parent = ObjGetRelations( item ).parent;
  
  cmn.GetObjectSfx();
  ObjAttach( item, "int_taskpanel_impl" );
  --ObjSet( "spr_hocardindex3_symbol_"..num, { res = "assets/levels/level1/ho_hocardindex3/layers/amulets/amulet_"..num, pos_z = 5 } );
  --ObjSet( "spr_hocardindex3_symbol_"..num.."_shadow", { alp = 0 } );
  --ObjSet( "spr_hocardindex3_symbol_"..num, { alp = 0 } );  

end;
--*********************************************************************************************************************
function private.UseAmulet ( num )

  if num == 1 then
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hocardindex3_insert_hand" );
  elseif num == 2 then
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hocardindex3_insert_sign" );
  elseif num == 3 then
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hocardindex3_insert_pen" );
  elseif num == 4 then
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hocardindex3_insert_battery" );
  end;

  local item = "spr_hocardindex3_objects_amulet_"..num;
  local bool = true;
  SetCursor( CURSOR_DEFAULT );

  if ( ObjIntersect( item, "obj_hocardindex3_use_amulet_"..num ) ) then
--
      bool = false;
      int.Lock( true );
      parent_obj = "ho_hocardindex3";
--
      local func_end = function ()

          private.UseAmuletEnd( num, num );

      end;          
--
        ObjDelete( item );    
--      
--      --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hocardindex3_lock"..num );
--
      ObjAnimate( "obj_hocardindex3_objects_open_"..num, "alp", 0, 0, func_end, 
      {
        0.0, 0, 0,
        0.3, 0, 1
      } );
--
  end;

  if ( bool ) then

    ObjAttach( item, private.win_hocardindex3.parent );
    --ObjSet( item, { res = "assets/levels/level1/ho_hocardindex3/layers/amulet_"..num, pos_z = 0 } );
    --ObjSet( item.."_shadow", { alp = 1 } );      
      cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.UseAmuletEnd( num1, num2 )

  cmn.HoTaskFind( "", "amulet_"..num1 );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].amulet[ num1 ] = 1;
  
  if ( num1 == 4) then
    
    ObjSet( "spr_hocardindex3_batt_inside", { alp = 1 } );
    
  end;
    
  int.Lock( false ); 

  ObjDelete( "obj_hocardindex3_use_amulet_"..num2 );
  
  ObjSet( "obj_hocardindex3_objects_open_"..num1, { alp = 1, input = true } );
  ObjSet( "spr_hocardindex3_objects_amulet_"..num1+1, { input = true } );  
  ObjSet( "obj_hocardindex3_use_amulet_"..num1+1, { input = true } );
  
  if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].set == 12 ) then
  
    ObjSet( "txt_hocardindex3_task_"..num1+1, { alp = 1 } );
    
  end;
  
  private.Check( 7 );
  
  local is_win = true;
  
  for i = 1, 4 do

    if (ng_global.progress[ ng_global.currentprogress ][ "win_hocardindex3" ].amulet[ i ] ~= 1 ) then

      is_win = false;
      
    end;
    
  end;  
  
  if (is_win) then    

    local func_end = function ()
      
      ObjSet( "txt_hocardindex3_task_battery", { alp = 0} );

    end;      

    --ObjSet( "anm_hotreasury3_anims_opn_box", { alp = 1 } );
    --AnimPlay( "anm_hotreasury3_anims_opn_box", "DoAnim", func_end );
    func_end();
  end;

end;  
--*********************************************************************************************************************
function private.GetCard( )

  cmn.HoTaskFind( "spr_hocardindex3_objects_amulet_5", "card" );    
  common_impl.PassingHoCheck();  
    --int.Lock( true );
    --MsgSend( Event_DialogHo_Show, {} );  
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************