-- name=ho_horepair3_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  
  room.Define( "ho_horepair3_rpl" );
  game.relations[ "ho_horepair3_rpl" ].exitroom = "rm_towerroof3";
  private.room_objname = "ho_horepair3_rpl";

  private.task_name = "win_horepair3_rpl";  
  private.win_horepair3_rpl = {};
  private.win_horepair3_rpl.parent = "";  
  private.win_horepair3_rpl.current_light = 0;
  
  --------------------------------------------------------------------------------------------
  -- function opn_horepair3_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_horepair3_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_horepair3_rpl", opn_horepair3_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_horepair3_rpl_func = function ()


  end;
  cmn.AddSubscriber( "win_horepair3_rpl", win_horepair3_rpl_func );
  --------------------------------------------------------------------------------------------------
  local start_horepair3_rpl_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;
          
      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_amulet_2" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_1_amulet_2" );          
        ObjDelete( "spr_horepair3_rpl_objects_1_cap" );
        ObjDelete( "obj_horepair3_rpl_use_amulet_2" );
        ObjSet( "anm_horepair3_rpl_objects_1_use_amulet_2", { alp = 1, frame = 49 } );        
        ObjSet( "spr_horepair3_rpl_objects_1_lamp_3", { alp = 1, input = true } );
        ObjSet( "spr_horepair3_rpl_objects_1_lamp_drag", { input = true } );        
        ObjSet( "obj_horepair3_rpl_objects_1_use_lamp_3", { alp = 1, input = true } );    

      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_lamp_3" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_1_lamp_drag" );   
        ObjDelete( "spr_horepair3_rpl_objects_1_lamp_2" );
        ObjDelete( "spr_horepair3_rpl_objects_1_lamp_3" );
        ObjDelete( "obj_horepair3_rpl_objects_1_use_lamp_3" );          
        ObjSet( "spr_horepair3_rpl_objects_1_soldering", { alp = 1, input = true } );
        ObjSet( "spr_horepair3_rpl_objects_1_soldering_drag", { input = true } );          
        ObjSet( "obj_horepair3_rpl_objects_1_use_soldering", { alp = 1, input = true } ); 
        ObjSet( "anm_horepair3_rpl_objects_1_use_lamp", { alp = 1, frame = 18 } );        

      end;    

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_soldering" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_1_soldering_drag" );    
        ObjDelete( "anm_horepair3_rpl_objects_1_spark" );
        ObjDelete( "obj_horepair3_rpl_objects_1_use_soldering" );
        ObjDelete( "anm_horepair3_rpl_smoke" );
        ObjDelete( "spr_horepair3_rpl_objects_1_soldering" );
        ObjDelete( "spr_horepair3_rpl_objects_1_soldering_wire" );
        ObjDelete( "spr_horepair3_rpl_objects_1_soldering_shadow" );      
        ObjSet( "anm_horepair3_rpl_objects_1_use_soldering", { alp = 1, frame = 88 } );    
        ObjDelete( "anm_horepair3_rpl_objects_1_use_lamp" );
        ObjSet( "anm_horepair3_rpl_objects_1_lamp", { alp = 1, playing = true } );        

      end;        

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_handle_2" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_handle_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_handle_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_handle_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_box_1" );     
        ObjSet( "anm_horepair3_rpl_objects_2_open_box_1", { alp = 1, frame = 76 } );   
        ObjSet( "spr_horepair3_rpl_objects_2_coil", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_coil_drag", { input = true } );       
        ObjSet( "obj_horepair3_rpl_objects_2_use_coil", { input = true } );    
        ObjSet( "spr_horepair3_rpl_objects_2_screwdriver", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_screwdriver_drag", { input = true } );       
        ObjSet( "obj_horepair3_rpl_objects_3_use_screwdriver", { input = true } );   

      end;     

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_coil" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_coil_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_coil" );
        ObjDelete( "spr_horepair3_rpl_objects_2_coil" ); 
        ObjSet( "obj_horepair3_rpl_objects_2_coil_done", { alp = 1 } );     

      end;    

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_cog" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_cog_drag" );    
        ObjDelete( "obj_horepair3_rpl_objects_2_use_cog" );
        ObjDelete( "spr_horepair3_rpl_objects_2_cog_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_box_3" ); 
        ObjSet( "anm_horepair3_rpl_objects_2_open_box_3", { alp = 1, frame = 57 } );   
        ObjSet( "spr_horepair3_rpl_objects_2_socket_2", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_socket_drag", { input = true } );       
        ObjSet( "obj_horepair3_rpl_objects_2_use_socket", { input = true } );     

      end;    

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_socket" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_socket_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_socket" );
        ObjDelete( "spr_horepair3_rpl_objects_2_socket_2" );
        ObjSet( "spr_horepair3_rpl_objects_2_socket_1", { alp = 1 } );          
        
        ObjSet( "spr_horepair3_rpl_objects_2_wire", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_wire_drag", { input = true } );           
        ObjSet( "obj_horepair3_rpl_objects_2_use_wire", { input = true } );  

        ObjSet( "spr_horepair3_rpl_objects_2_bolt_1", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_1_drag", { input = true } );        
        ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_1", { input = true } ); 

        ObjSet( "spr_horepair3_rpl_objects_2_bolt_2", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_2_drag", { input = true } );        
        ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_2", { input = true } ); 

        ObjSet( "spr_horepair3_rpl_objects_2_bolt_3", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_3_drag", { input = true } );        
        ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_3", { input = true } ); 

        ObjSet( "spr_horepair3_rpl_objects_2_bolt_4", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_4_drag", { input = true } );        
        ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_4", { input = true } );     

      end;   

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wire" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_wire_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_wire" );
        ObjDelete( "spr_horepair3_rpl_objects_2_slot_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wire" );    
        ObjSet( "spr_horepair3_rpl_objects_2_wire_done", { alp = 1 } );       

      end;  

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_1" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_1_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_bolt_1" );
        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_1" );
        ObjSet( "spr_horepair3_rpl_objects_2_slot_1", { alp = 0 } );  
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_1_done", { alp = 1 } );     

      end;      

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_2" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_2_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_bolt_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_2" );
        ObjSet( "spr_horepair3_rpl_objects_2_slot_2", { alp = 0 } );  
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_2_done", { alp = 1 } );     

      end;    

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_3" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_3_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_bolt_3" );
        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_3" );
        ObjSet( "spr_horepair3_rpl_objects_2_slot_3", { alp = 0 } );  
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_3_done", { alp = 1 } );     

      end;  

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_4" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_4_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_bolt_4" );
        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_4" );
        ObjSet( "spr_horepair3_rpl_objects_2_slot_4", { alp = 0 } );  
        ObjSet( "spr_horepair3_rpl_objects_2_bolt_4_done", { alp = 1 } );     

      end;      

      if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_all"] ) then

        --ObjSet( "obj_horepair3_objects_2_use_wrench", { input = true } );  
        if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "clk_bag"] ) then
                                         
          ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1, input = true } );
          ObjSet( "spr_horepair3_rpl_objects_2_wrench_drag", { input = true } );
          ObjSet( "obj_horepair3_rpl_objects_2_use_wrench", { input = true } ); 
          
        end;
    
        ObjDelete( "spr_horepair3_rpl_objects_2_slot_1" );          

      end;     

      if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "clk_bag"] ) then

        --ObjSet( "anm_horepair3_rpl_objects_2_bag_open", { alp = 1, frame = 25 } );    
        ObjDelete( "anm_horepair3_rpl_objects_2_bag_open" );
        ObjDelete( "obj_horepair3_rpl_objects_2_click_bag" );
        ObjSet( "obj_horepair3_rpl_objects_2_bag", { alp = 1 } );
        ObjSet( "spr_horepair3_rpl_objects_2_bag", { alp = 1 } );
        ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1 } );
      
        if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_1"] and
            ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_2"] and
            ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_3"] and
            ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_4"] ) then
                                         
          ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1, input = true } );
          ObjSet( "spr_horepair3_rpl_objects_2_wrench_drag", { input = true } );
          ObjSet( "obj_horepair3_rpl_objects_2_use_wrench", { input = true } ); 
          
        end;    

      end; 

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wrench" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_wrench_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_2_use_wrench" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wrench" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wrench_over" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wrench_shadow" );    

      end;  

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_key" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_3_key_drag" );    
        ObjDelete( "obj_horepair3_rpl_objects_3_use_key" );
        ObjDelete( "spr_horepair3_rpl_objects_3_key_2" );
        ObjDelete( "spr_horepair3_rpl_objects_3_box_2" );  
        ObjSet( "anm_horepair3_rpl_objects_3_open_box_2", { alp = 1, frame = 73 } );   
      
        if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_screwdriver" ] ) then

          ObjSet( "obj_horepair3_rpl_objects_3_use_fuse", { input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_3_fuse_2", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_3_fuse_drag", { input = true } );    

        end;

      end;  

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_fuse" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_3_fuse_drag" );   
        ObjDelete( "obj_horepair3_rpl_objects_3_use_fuse" );
        ObjDelete( "spr_horepair3_rpl_objects_3_fuse_2" );  
        ObjSet( "anm_horepair3_rpl_objects_3_use_fuse", { alp = 1, frame = 45 } );          

      end;  

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_detal" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_3_detal_drag" );    
        ObjDelete( "obj_horepair3_rpl_objects_3_use_detal" );
        ObjDelete( "spr_horepair3_rpl_objects_3_detal_3" );
        ObjDelete( "spr_horepair3_rpl_objects_3_detal_2" );                 
        ObjSet( "spr_horepair3_rpl_objects_3_detal_done", { alp = 1 } );      

      end;    

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_screwdriver" ] ) then

        ObjDelete( "spr_horepair3_rpl_objects_2_screwdriver_drag" );    
        ObjDelete( "obj_horepair3_rpl_objects_3_use_screwdriver" );
        ObjDelete( "spr_horepair3_rpl_objects_2_screwdriver" );   
        ObjDelete( "vid_horepair3_rpl_objects_screw_anim" ); 
        ObjSet( "obj_horepair3_rpl_objects_3_use_detal", { input = true } );
        ObjSet( "spr_horepair3_rpl_objects_3_detal_3", { alp = 1, input = true } ); 
        ObjSet( "spr_horepair3_rpl_objects_3_detal_drag", { input = true } );         
      
        if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_key" ] ) then

          ObjSet( "obj_horepair3_rpl_objects_3_use_fuse", { input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_3_fuse_2", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_3_fuse_drag", { input = true } );    

        end;
    
        ObjDelete( "spr_horepair3_rpl_objects_3_cap_1" );   
        ObjSet( "spr_horepair3_rpl_objects_3_cap_2", { alp = 1 } );        

      end;    

    end;

  end;
  cmn.AddSubscriber( "win_horepair3_rpl", start_horepair3_rpl_func );
  --------------------------------------------------------------------------------------------------

  --obj_1
  ObjSet( "spr_horepair3_rpl_objects_1_amulet_2", { event_mdown = function () private.GetAmulet_2(); end, event_dragdrop = function () private.UseAmulet_2(); end } );
  ObjSet( "spr_horepair3_rpl_objects_1_lamp_drag", { event_mdown = function () private.GetLamp_3(); end, event_dragdrop = function () private.UseLamp_3(); end } ); 
  ObjSet( "spr_horepair3_rpl_objects_1_soldering_drag", { event_mdown = function () private.GetSoldering(); end, event_dragdrop = function () private.UseSoldering(); end } ); 
  
  --obj_2    
  ObjSet( "spr_horepair3_rpl_objects_2_handle_drag", { event_mdown = function () private.GetHandle_2(); end, event_dragdrop = function () private.UseHandle_2(); end } );  
  ObjSet( "spr_horepair3_rpl_objects_2_coil_drag", { event_mdown = function () private.GetCoil(); end, event_dragdrop = function () private.UseCoil(); end } );      
  ObjSet( "spr_horepair3_rpl_objects_2_cog_drag", { event_mdown = function () private.GetCog(); end, event_dragdrop = function () private.UseCog(); end } );          
  ObjSet( "spr_horepair3_rpl_objects_2_socket_drag", { event_mdown = function () private.GetSocket(); end, event_dragdrop = function () private.UseSocket(); end } );              
  ObjSet( "spr_horepair3_rpl_objects_2_wire_drag", { event_mdown = function () private.GetWire(); end, event_dragdrop = function () private.UseWire(); end } );                  
  ObjSet( "spr_horepair3_rpl_objects_2_bolt_1_drag", { event_mdown = function () private.GetBolt( 1 ); end, event_dragdrop = function () private.UseBolt( 1 ); end } );                  
  ObjSet( "spr_horepair3_rpl_objects_2_bolt_2_drag", { event_mdown = function () private.GetBolt( 2 ); end, event_dragdrop = function () private.UseBolt( 2 ); end } );                  
  ObjSet( "spr_horepair3_rpl_objects_2_bolt_3_drag", { event_mdown = function () private.GetBolt( 3 ); end, event_dragdrop = function () private.UseBolt( 3 ); end } );                  
  ObjSet( "spr_horepair3_rpl_objects_2_bolt_4_drag", { event_mdown = function () private.GetBolt( 4 ); end, event_dragdrop = function () private.UseBolt( 4 ); end } );                        
  ObjSet( "obj_horepair3_rpl_objects_2_click_bag", { event_mdown = function () private.ClkBag( 4 ); end } );                        
  ObjSet( "spr_horepair3_rpl_objects_2_wrench_drag", { event_mdown = function () private.GetWrench(); end, event_dragdrop = function () private.UseWrench(); end } );                      
  ObjSet( "spr_horepair3_rpl_objects_2_screwdriver_drag", { event_mdown = function () private.GetScrewdriver(); end, event_dragdrop = function () private.UseScrewdriver(); end } );          
        
  --obj_3    
  ObjSet( "spr_horepair3_rpl_objects_3_key_drag", { event_mdown = function () private.GetKey(); end, event_dragdrop = function () private.UseKey(); end } );              
  ObjSet( "spr_horepair3_rpl_objects_3_fuse_drag", { event_mdown = function () private.GetFuse(); end, event_dragdrop = function () private.UseFuse(); end } );                
  ObjSet( "spr_horepair3_rpl_objects_3_detal_drag", { event_mdown = function () private.GetDetal(); end, event_dragdrop = function () private.UseDetal(); end } );                  
    
end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()


end;
--*********************************************************************************************************************
function public.ResetHO ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].start = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects = {};
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_amulet_2" ] = false;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_lamp_3"] = false;   
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_soldering"] = false;     
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_handle_2"] = false;  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_coil"] = false;  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_cog"] = false;   
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_socket"] = false;     
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wire"] = false;  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_1"] = false;                                          
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_2"] = false;                                          
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_3"] = false;                                          
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_4"] = false;                                          
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_all"] = false;   
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "clk_bag"] = false;                                                
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wrench"] = false;   
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_screwdriver"] = false;        

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_key"] = false;  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_fuse"] = false; 
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_detal"] = false;     

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, true );     
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "horepair3_rpl" );

  end;

  if ( not cmn.IsEventDone( "opn_horepair3_rpl" ) ) then

      cmn.SetEventDone( "opn_horepair3_rpl" );
      cmn.CallEventHandler( "opn_horepair3_rpl" );
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects = {};
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_amulet_2" ] = false;
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_lamp_3"] = false;   
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_soldering"] = false;     
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_handle_2"] = false;  
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_coil"] = false;  
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_cog"] = false;   
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_socket"] = false;     
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wire"] = false;  
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_1"] = false;                                          
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_2"] = false;                                          
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_3"] = false;                                          
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_4"] = false;                                          
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_all"] = false;   
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "clk_bag"] = false;                                                
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wrench"] = false;   
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_screwdriver"] = false;        

      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_key"] = false;  
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_fuse"] = false; 
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_detal"] = false;                      

  end;        

  local ho_tasks = {}; 

  interface.TaskPanelTaskAdd( ho_tasks, "amulet_2",  1, 0, { { "spr_horepair3_rpl_objects_1_amulet_2", "obj_horepair3_rpl_use_amulet_2"  } } );  
  interface.TaskPanelTaskAdd( ho_tasks, "lamp_3",    1, 0, { { "spr_horepair3_rpl_objects_1_lamp_3", "obj_horepair3_rpl_objects_1_use_lamp_3"  } } );  
  interface.TaskPanelTaskAdd( ho_tasks, "soldering", 1, 0, { { "spr_horepair3_rpl_objects_1_soldering", "obj_horepair3_rpl_objects_1_use_soldering"  } } );    
  
  interface.TaskPanelTaskAdd( ho_tasks, "handle_2", 1, 0, { { "spr_horepair3_rpl_objects_2_handle_2", "obj_horepair3_rpl_objects_2_use_handle_2"  } } );      
  interface.TaskPanelTaskAdd( ho_tasks, "coil", 1, 0, { { "spr_horepair3_rpl_objects_2_coil", "obj_horepair3_rpl_objects_2_use_coil"  } } );        
  interface.TaskPanelTaskAdd( ho_tasks, "cog", 1, 0, { { "spr_horepair3_rpl_objects_2_cog_2", "obj_horepair3_rpl_objects_2_use_cog"  } } );          
  interface.TaskPanelTaskAdd( ho_tasks, "socket", 1, 0, { { "spr_horepair3_rpl_objects_2_socket_2", "obj_horepair3_rpl_objects_2_use_socket"  } } );            
  interface.TaskPanelTaskAdd( ho_tasks, "wire", 1, 0, { { "spr_horepair3_rpl_objects_2_wire", "obj_horepair3_rpl_objects_2_use_wire"  } } );     
  interface.TaskPanelTaskAdd( ho_tasks, "bolt_1", 1, 0, { { "spr_horepair3_rpl_objects_2_bolt_1", "obj_horepair3_rpl_objects_2_use_bolt_1"  } } );    
  interface.TaskPanelTaskAdd( ho_tasks, "bolt_2", 1, 0, { { "spr_horepair3_rpl_objects_2_bolt_2", "obj_horepair3_rpl_objects_2_use_bolt_2"  } } );                
  interface.TaskPanelTaskAdd( ho_tasks, "bolt_3", 1, 0, { { "spr_horepair3_rpl_objects_2_bolt_3", "obj_horepair3_rpl_objects_2_use_bolt_3"  } } );                
  interface.TaskPanelTaskAdd( ho_tasks, "bolt_4", 1, 0, { { "spr_horepair3_rpl_objects_2_bolt_4", "obj_horepair3_rpl_objects_2_use_bolt_4"  } } );  
  interface.TaskPanelTaskAdd( ho_tasks, "clk_bag", 1, 0, { { "obj_horepair3_rpl_objects_2_click_bag"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "wrench", 1, 0, { { "spr_horepair3_rpl_objects_2_wrench", "obj_horepair3_rpl_objects_2_use_wrench"  } } );   
  interface.TaskPanelTaskAdd( ho_tasks, "screwdriver", 1, 0, { { "spr_horepair3_rpl_objects_2_screwdriver", "obj_horepair3_rpl_objects_3_use_screwdriver"  } } );          

  interface.TaskPanelTaskAdd( ho_tasks, "key", 1, 0, { { "spr_horepair3_rpl_objects_3_key_2", "obj_horepair3_rpl_objects_3_use_key"  } } );     
  interface.TaskPanelTaskAdd( ho_tasks, "fuse", 1, 0, { { "spr_horepair3_rpl_objects_3_fuse_2", "obj_horepair3_rpl_objects_3_use_fuse"  } } );      
  interface.TaskPanelTaskAdd( ho_tasks, "detal", 1, 0, { { "spr_horepair3_rpl_objects_3_detal_3", "obj_horepair3_rpl_objects_3_use_detal"  } } );                          
  
  --interface.TaskPanelTaskAdd( ho_tasks, "bottle", 1, 0, { { "spr_horepair3_rpl_win_bottle"  } } );  
  
  int.TaskPanelShow( ho_tasks );

  ObjSet( "obj_int_taskpanel", { alp = 0,input = false } );
  ObjSet( "spr_int_taskpanel", { alp = 0,input = false } );  
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );  

  cmn.StopAllMus();

  cmn.StopAllEnv( "audio/level3/env/aud_rm_towerroof3_env" );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_towerroof3_env", 1, 1 );
  
end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "spr_int_taskpanel", { alp = 1,input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1,input = true } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );    
  ObjSet( "int_inventory_impl", { input = true } );
  --ObjAttach( "obj_horepair3_rpl_taskpanel","ho_horepair3_rpl" );
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  cmn.HoTaskFind( "", name ); 

end;
--*********************************************************************************************************************
function private.SetLight() 
  
  private.win_horepair3_rpl.current_light = private.win_horepair3_rpl.current_light + 1;
  
  --зажигаем лампу
  ObjSet( "spr_horepair3_rpl_light_green_"..private.win_horepair3_rpl.current_light, { alp = 1 } );
  ObjDelete( "spr_horepair3_rpl_light_red_"..private.win_horepair3_rpl.current_light );                      
  
end;
--------------------------------------------------------------------------------------------
-- function STAGE_1 () end;
--*********************************************************************************************************************
  function private.GetAmulet_2 ()

    local item = "spr_horepair3_rpl_objects_1_amulet_2";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjAttach( item, "int_taskpanel_impl" );

  end;
  --*********************************************************************************************************************
  function private.UseAmulet_2 ()

    local item = "spr_horepair3_rpl_objects_1_amulet_2";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_use_amulet_2" ) ) then
      
        bool = false;

        local func_end = function ()

          ObjDelete( "spr_horepair3_rpl_objects_1_cap" );
          ObjDelete( "obj_horepair3_rpl_use_amulet_2" );
          ObjSet( "anm_horepair3_rpl_objects_1_use_amulet_2", { alp = 1, frame = 49 } );        
          ObjSet( "spr_horepair3_rpl_objects_1_lamp_3", { alp = 1, input = true } );
          ObjSet( "spr_horepair3_rpl_objects_1_lamp_drag", { input = true } );        
          ObjSet( "obj_horepair3_rpl_objects_1_use_lamp_3", { alp = 1, input = true } );     
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_amulet_2" ] = true;
          
          private.CompleteTask ( "amulet_2" );
          
          int.Lock( false );        

        end;          
          
        ObjDelete( item );      
        
        int.Lock( true );     
        ObjSet( "spr_horepair3_rpl_objects_1_cap", { alp = 0 } );      
        ObjSet( "anm_horepair3_rpl_objects_1_use_amulet_2", { alp = 1 } );
        
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_light" );
        AnimPlay( "anm_horepair3_rpl_objects_1_use_amulet_2", "DoAnim", func_end );

    end;

    if ( bool ) then

      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetLamp_3 ()

    cmn.SetCursor( CURSOR_NULL );  
    
    local item = "spr_horepair3_rpl_objects_1_lamp_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( "spr_horepair3_rpl_objects_1_lamp_3", { alp = 0 } );
    ObjSet( item, { alp = 1 } );
    ObjAttach( item, "int_taskpanel_impl" );

  end;
  --*********************************************************************************************************************
  function private.UseLamp_3 ()

    local item = "spr_horepair3_rpl_objects_1_lamp_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_1_use_lamp_3" ) ) then
      
        bool = false;

        local func_end = function ()

          ObjDelete( "spr_horepair3_rpl_objects_1_lamp_2" );
          ObjDelete( "spr_horepair3_rpl_objects_1_lamp_3" );
          ObjDelete( "obj_horepair3_rpl_objects_1_use_lamp_3" );
          ObjSet( "anm_horepair3_rpl_objects_1_use_lamp", { alp = 1 } );    
      
          local func_end_2 = function ()                 

            ObjSet( "spr_horepair3_rpl_objects_1_soldering", { alp = 1, input = true } );
            ObjSet( "spr_horepair3_rpl_objects_1_soldering_drag", { input = true } );          
            ObjSet( "obj_horepair3_rpl_objects_1_use_soldering", { alp = 1, input = true } ); 
            ObjSet( "anm_horepair3_rpl_objects_1_use_lamp", { frame = 18 } );              
         
            ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_lamp_3"] = true;
            private.CompleteTask ( "lamp_3" );          
            
              cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_loop_ball", 1 );
            int.Lock( false );                
            
          end;     
       
          AnimPlay( "anm_horepair3_rpl_objects_1_use_lamp", "DoAnim", func_end_2 );   

        end;          
          
        ObjDelete( item );    
    
        int.Lock( true ); 
   
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_ball" );      
        ObjAnimate( "anm_horepair3_rpl_objects_1_use_lamp", "alp", 0, 0, "", 
        {
          0.0, 0, 0,
          0.3, 0, 1
        } );
        ObjAnimate( "spr_horepair3_rpl_objects_1_lamp_2", "alp", 0, 0, func_end, 
        {
          0.0, 0, 1,
          0.3, 0, 0
        } );

    end;

    if ( bool ) then
      
      ObjSet( "spr_horepair3_rpl_objects_1_lamp_3", { alp = 1 } );
      ObjSet( item, { alp = 0 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetSoldering ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_1_soldering_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( "spr_horepair3_rpl_objects_1_soldering_drag", { alp = 1, ang = 0 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_1_soldering", { alp = 0 } );
    ObjSet( "spr_horepair3_rpl_objects_1_soldering_wire", { alp = 0 } );
    ObjSet( "spr_horepair3_rpl_objects_1_soldering_shadow", { alp = 0 } );  
    ObjSet( "anm_horepair3_rpl_smoke", { alp = 0 } );

  end;
  --*********************************************************************************************************************
  function private.UseSoldering ()

    local item = "spr_horepair3_rpl_objects_1_soldering_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_1_use_soldering" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "anm_horepair3_rpl_objects_1_spark" );
        ObjDelete( "obj_horepair3_rpl_objects_1_use_soldering" );
        ObjDelete( "anm_horepair3_rpl_smoke" );
        ObjDelete( "spr_horepair3_rpl_objects_1_soldering" );
        ObjDelete( "spr_horepair3_rpl_objects_1_soldering_wire" );
        ObjDelete( "spr_horepair3_rpl_objects_1_soldering_shadow" );
        ObjSet( "anm_horepair3_rpl_objects_1_use_soldering", { alp = 1 } );
        
        local func_end_2 = function ()   
     
          ObjSet( "anm_horepair3_rpl_objects_1_use_soldering", { frame = 88 } );    
          ObjDelete( "anm_horepair3_rpl_objects_1_use_lamp" );
          ObjSet( "anm_horepair3_rpl_objects_1_lamp", { alp = 1, playing = true } );        
            
          cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_loop_ball", 1 ); 
          
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_soldering"] = true;
          private.CompleteTask ( "soldering" );                  
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );      
        
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_repair_wire_1" );  
        AnimPlay( "anm_horepair3_rpl_objects_1_use_soldering", "DoAnim", func_end_2 );               

    end;

    if ( bool ) then

      ObjSet( "spr_horepair3_rpl_objects_1_soldering_drag", { alp = 0, ang = 2.22 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_1_soldering", { alp = 1 } );    
      ObjSet( "spr_horepair3_rpl_objects_1_soldering_wire", { alp = 1 } );
      ObjSet( "spr_horepair3_rpl_objects_1_soldering_shadow", { alp = 1 } );       
      ObjSet( "anm_horepair3_rpl_smoke", { alp = 1 } );    
      
      cmn.WrongApply();

    end;

  end;
--------------------------------------------------------------------------------------------
-- function STAGE_2 () end;  
--*********************************************************************************************************************
  function private.GetHandle_2 ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_handle_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( "spr_horepair3_rpl_objects_2_handle_drag", { alp = 1 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_handle_2", { alp = 0 } );
    ObjSet( "spr_horepair3_rpl_objects_slot_4", { alp = 1 } );

  end;
  --*********************************************************************************************************************
  function private.UseHandle_2 ()

    local item = "spr_horepair3_rpl_objects_2_handle_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_handle_2" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_handle_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_handle_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_box_1" );
        ObjSet( "anm_horepair3_rpl_objects_2_open_box_1", { alp = 1 } );
        
        local func_end_2 = function ()        
            
          ObjSet( "anm_horepair3_rpl_objects_2_open_box_1", { alp = 1, frame = 76 } );   
          ObjSet( "spr_horepair3_rpl_objects_2_coil", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_coil_drag", { input = true } );       
          ObjSet( "obj_horepair3_rpl_objects_2_use_coil", { input = true } );    
          ObjSet( "spr_horepair3_rpl_objects_2_screwdriver", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_screwdriver_drag", { input = true } );       
          ObjSet( "obj_horepair3_rpl_objects_3_use_screwdriver", { input = true } );           
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_handle_2"] = true;
          private.CompleteTask ( "handle_2" );                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true ); 
   
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_handle_box" );     
        AnimPlay( "anm_horepair3_rpl_objects_2_open_box_1", "DoAnim", func_end_2 );               

    end;

    if ( bool ) then

      ObjSet( "spr_horepair3_rpl_objects_2_handle_drag", { alp = 0 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_handle_2", { alp = 1 } );   
      ObjSet( "spr_horepair3_rpl_objects_slot_4", { alp = 0 } );    
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetCoil ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_coil_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( "spr_horepair3_rpl_objects_2_coil_drag", { alp = 1, ang = 0 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_coil", { alp = 0 } ); 
    ObjSet( "spr_horepair3_rpl_objects_2_slot_3", { alp = 1 } );

  end;
  --*********************************************************************************************************************
  function private.UseCoil ()

    local item = "spr_horepair3_rpl_objects_2_coil_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_coil" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_coil" );
        ObjDelete( "spr_horepair3_rpl_objects_2_coil" );
        
        local func_end_2 = function ()        
            
          ObjSet( "obj_horepair3_rpl_objects_2_coil_done", { alp = 1 } );   
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_coil"] = true;
          private.CompleteTask ( "coil" );                                  
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );   
     
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_wire_1" );    
        ObjAnimate( "obj_horepair3_rpl_objects_2_coil_done", "alp", 0, 0, func_end_2, 
        {
          0.0, 0, 0,
          0.3, 0, 1
        } );         

    end;

    if ( bool ) then

      ObjSet( "spr_horepair3_rpl_objects_2_coil_drag", { alp = 0, ang = -1.69 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_coil", { alp = 1 } );    
      ObjSet( "spr_horepair3_rpl_objects_2_slot_3", { alp = 0 } );    
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetCog ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_cog_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( "spr_horepair3_rpl_objects_2_cog_drag", { alp = 1 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_cog_2", { alp = 0 } );

  end;
  --*********************************************************************************************************************
  function private.UseCog ()

    local item = "spr_horepair3_rpl_objects_2_cog_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_cog" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_cog" );
        ObjDelete( "spr_horepair3_rpl_objects_2_cog_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_box_3" );
        ObjSet( "anm_horepair3_rpl_objects_2_open_box_3", { alp = 1 } );
        
        local func_end_2 = function ()        
            
          ObjSet( "anm_horepair3_rpl_objects_2_open_box_3", { alp = 1, frame = 57 } );   
          ObjSet( "spr_horepair3_rpl_objects_2_socket_2", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_socket_drag", { input = true } );       
          ObjSet( "obj_horepair3_rpl_objects_2_use_socket", { input = true } );          
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_cog"] = true;
          private.CompleteTask ( "cog" );                                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );    
      
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_mech_in_box" );   
        AnimPlay( "anm_horepair3_rpl_objects_2_open_box_3", "DoAnim", func_end_2 );               

    end;

    if ( bool ) then

      ObjSet( "spr_horepair3_rpl_objects_2_cog_drag", { alp = 0 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_cog_2", { alp = 1 } );   
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetSocket ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_socket_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( "spr_horepair3_rpl_objects_2_socket_drag", { alp = 1, ang = 0 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_socket_2", { alp = 0 } ); 

  end;
  --*********************************************************************************************************************
  function private.UseSocket ()

    local item = "spr_horepair3_rpl_objects_2_socket_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_socket" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_socket" );
        ObjDelete( "spr_horepair3_rpl_objects_2_socket_2" );
        
        local func_end_2 = function ()                
          
          ObjSet( "spr_horepair3_rpl_objects_2_socket_1", { alp = 1 } );    
  
          ObjSet( "spr_horepair3_rpl_objects_2_wire", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_wire_drag", { input = true } );                
          ObjSet( "obj_horepair3_rpl_objects_2_use_wire", { input = true } );   
          
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_1", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_1_drag", { input = true } );        
          ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_1", { input = true } ); 
     
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_2", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_2_drag", { input = true } );        
          ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_2", { input = true } ); 
          
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_3", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_3_drag", { input = true } );        
          ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_3", { input = true } ); 
          
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_4", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_4_drag", { input = true } );        
          ObjSet( "obj_horepair3_rpl_objects_2_use_bolt_4", { input = true } );                            
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_socket"] = true;
          private.CompleteTask ( "socket" );                                                  
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );  
    
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_thing_for_bolts" );    
        ObjAnimate( "spr_horepair3_rpl_objects_2_socket_1", "alp", 0, 0, func_end_2, 
        {
          0.0, 0, 0,
          0.3, 0, 1
        } );         

    end;

    if ( bool ) then

      ObjSet( "spr_horepair3_rpl_objects_2_socket_drag", { alp = 0, ang = -0.87 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_socket_2", { alp = 1 } );    
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetWire ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_wire_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1, ang = -0.41 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_wire", { alp = 0 } ); 
    
    if ( ObjGet( "obj_horepair3_rpl_objects_2_use_wire" ).input ) then
    
      ObjSet( "spr_horepair3_rpl_objects_2_slot_2", { alp = 1 } );   
      
    end;

  end;
  --*********************************************************************************************************************
  function private.UseWire ()

    local item = "spr_horepair3_rpl_objects_2_wire_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_wire" ) and
        ObjGet( "obj_horepair3_rpl_objects_2_use_wire" ).input ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_wire" );
        ObjDelete( "spr_horepair3_rpl_objects_2_slot_2" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wire" );
        
        local func_end_2 = function ()                
          
          ObjSet( "spr_horepair3_rpl_objects_2_wire_done", { alp = 1 } );   
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wire"] = true;
          private.CompleteTask ( "wire" );                                                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true ); 
   
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_wire_2" );       
        ObjAnimate( "spr_horepair3_rpl_objects_2_wire_done", "alp", 0, 0, func_end_2, 
        {
          0.0, 0, 0,
          0.3, 0, 1
        } );         

    end;

    if ( bool ) then

      ObjSet( item, { alp = 0, ang = 2.25 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_wire", { alp = 1 } );
      ObjSet( "spr_horepair3_rpl_objects_2_slot_2", { alp = 0 } );        
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetBolt ( number )

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_bolt_"..number.."_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_bolt_"..number, { alp = 0 } ); 
    
    if ( ObjGet( "obj_horepair3_rpl_objects_2_use_bolt_"..number ).input ) then
    
      ObjSet( "spr_horepair3_rpl_objects_2_slot_1", { alp = 1 } );   
      
    end;

  end;
  --*********************************************************************************************************************
  function private.UseBolt ( number )

    local item = "spr_horepair3_rpl_objects_2_bolt_"..number.."_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_bolt_"..number ) and
        ObjGet( "obj_horepair3_rpl_objects_2_use_bolt_"..number ).input ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_bolt_"..number );
        ObjDelete( "spr_horepair3_rpl_objects_2_bolt_"..number );
        ObjSet( "spr_horepair3_rpl_objects_2_slot_1", { alp = 0 } );
        
        local func_end_2 = function ()                
          
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_"..number ] = true;
          private.CompleteTask ( "bolt_"..number );           
          
          ObjSet( "spr_horepair3_rpl_objects_2_bolt_"..number.."_done", { alp = 1 } ); 
          
          if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_1"] and
              ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_2"] and
              ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_3"] and
              ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_4"] ) then
                                           
            ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_all"] = true;  
            ObjDelete( "spr_horepair3_rpl_objects_2_slot_1" );    
      
            if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "clk_bag"] ) then
                                             
              ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1, input = true } );
              ObjSet( "spr_horepair3_rpl_objects_2_wrench_drag", { input = true } );
              ObjSet( "obj_horepair3_rpl_objects_2_use_wrench", { input = true } ); 
              
            end;    
            
          end;        
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );   
     
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_bolt" );      
        ObjAnimate( "spr_horepair3_rpl_objects_2_bolt_"..number.."_done", "alp", 0, 0, func_end_2, 
        {
          0.0, 0, 0,
          0.3, 0, 1
        } );         

    end;

    if ( bool ) then

      ObjSet( item, { alp = 0 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_bolt_"..number, { alp = 1 } );
      ObjSet( "spr_horepair3_rpl_objects_2_slot_1", { alp = 0 } );        
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.ClkBag ()

    local func_end_2 = function ()                

      --ObjSet( "anm_horepair3_rpl_objects_2_bag_open", { alp = 1, frame = 25 } ); 
      ObjDelete( "anm_horepair3_rpl_objects_2_bag_open" );   
      ObjDelete( "obj_horepair3_rpl_objects_2_click_bag" );
      ObjSet( "obj_horepair3_rpl_objects_2_bag", { alp = 1 } );
      ObjSet( "spr_horepair3_rpl_objects_2_bag", { alp = 1 } );
      ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1 } );
      
      if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_1"] and
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_2"] and
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_3"] and
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_bolt_4"] ) then
                                       
        ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1, input = true } );
        ObjSet( "spr_horepair3_rpl_objects_2_wrench_drag", { input = true } );
        ObjSet( "obj_horepair3_rpl_objects_2_use_wrench", { input = true } ); 
        
      end;      

      private.CompleteTask ( "clk_bag" );
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "clk_bag"] = true;      
      
      int.Lock( false );          

    end;      
    
    int.Lock( true ); 

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_klick_jacket" );     
    AnimPlay( "anm_horepair3_rpl_objects_2_bag_open", "DoAnim", func_end_2 );

  end;
  --*********************************************************************************************************************
  function private.GetWrench ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_wrench_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1, ang = 0 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 0 } );
    ObjSet( "spr_horepair3_rpl_objects_2_wrench_over", { alp = 0 } );
    ObjSet( "spr_horepair3_rpl_objects_2_wrench_shadow", { alp = 0 } );  
    ObjSet( "anm_horepair3_rpl_smoke", { alp = 0 } );

  end;
  --*********************************************************************************************************************
  function private.UseWrench ()

    local item = "spr_horepair3_rpl_objects_2_wrench_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_2_use_wrench" ) and
         ObjGet( "obj_horepair3_rpl_objects_2_use_wrench" ).input ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_2_use_wrench" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wrench" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wrench_over" );
        ObjDelete( "spr_horepair3_rpl_objects_2_wrench_shadow" );    
        ObjSet( "anm_horepair3_rpl_objects_2_use_key", { alp = 1 } );
        
        local func_end_2 = function ()          
            
          --ObjSet( "anm_horepair3_rpl_objects_2_use_key", { frame = 88 } );       
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_wrench" ] = true;
          private.CompleteTask ( "wrench" );                  
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );    
      
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_screw_bolts" );  
        AnimPlay( "anm_horepair3_rpl_objects_2_use_key", "DoAnim", func_end_2 );               

    end;

    if ( bool ) then

      ObjSet( item, { alp = 0, ang = -0.76 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_wrench", { alp = 1 } );    
      ObjSet( "spr_horepair3_rpl_objects_2_wrench_over", { alp = 1 } );
      ObjSet( "spr_horepair3_rpl_objects_2_wrench_shadow", { alp = 1 } );       
      
      cmn.WrongApply();

    end;

  end;
--------------------------------------------------------------------------------------------
-- function STAGE_3 () end;  
--*********************************************************************************************************************
  function private.GetKey ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_3_key_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1, ang = 0 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_3_key_2", { alp = 0 } );

  end;
  --*********************************************************************************************************************
  function private.UseKey ()

    local item = "spr_horepair3_rpl_objects_3_key_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_3_use_key" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_3_use_key" );
        ObjDelete( "spr_horepair3_rpl_objects_3_key_2" );
        ObjDelete( "spr_horepair3_rpl_objects_3_box_2" );
        ObjSet( "anm_horepair3_rpl_objects_3_open_box_2", { alp = 1 } );
        
        local func_end_2 = function ()        
            
          ObjSet( "anm_horepair3_rpl_objects_3_open_box_2", { alp = 1, frame = 73 } );   
          
          if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_screwdriver" ] ) then

            ObjSet( "obj_horepair3_rpl_objects_3_use_fuse", { input = true } ); 
            ObjSet( "spr_horepair3_rpl_objects_3_fuse_2", { alp = 1, input = true } ); 
            ObjSet( "spr_horepair3_rpl_objects_3_fuse_drag", { input = true } );             

          end;                    
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_key"] = true;
          private.CompleteTask ( "key" );                                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );      
        
       cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_open_key_box" ); 
        AnimPlay( "anm_horepair3_rpl_objects_3_open_box_2", "DoAnim", func_end_2 );               

    end;

    if ( bool ) then

      ObjSet( item, { alp = 0, ang = 0.64 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_3_key_2", { alp = 1 } );   
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetFuse ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_3_fuse_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_3_fuse_2", { alp = 0 } );

  end;
  --*********************************************************************************************************************
  function private.UseFuse ()

    local item = "spr_horepair3_rpl_objects_3_fuse_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_3_use_fuse" ) and
         ObjGet( "obj_horepair3_rpl_objects_3_use_fuse" ).input ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_3_use_fuse" );
        ObjDelete( "spr_horepair3_rpl_objects_3_fuse_2" );
        ObjSet( "anm_horepair3_rpl_objects_3_use_fuse", { alp = 1 } );
        
        local func_end_2 = function ()        
            
          ObjSet( "anm_horepair3_rpl_objects_3_use_fuse", { alp = 1, frame = 45 } );             
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_fuse"] = true;
          private.CompleteTask ( "fuse" );                                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );  

        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_transistors" );          
        AnimPlay( "anm_horepair3_rpl_objects_3_use_fuse", "DoAnim", func_end_2 );       
        
    end;

    if ( bool ) then

      ObjSet( item, { alp = 0 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_3_fuse_2", { alp = 1 } );   
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetDetal ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_3_detal_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_3_detal_3", { alp = 0 } );   

  end;
  --*********************************************************************************************************************
  function private.UseDetal ()

    local item = "spr_horepair3_rpl_objects_3_detal_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_3_use_detal" ) and
        ObjGet( "obj_horepair3_rpl_objects_3_use_detal" ).input ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_3_use_detal" );
        ObjDelete( "spr_horepair3_rpl_objects_3_detal_3" );
        ObjDelete( "spr_horepair3_rpl_objects_3_detal_2" );
        
        local func_end_2 = function ()                
          
          ObjSet( "spr_horepair3_rpl_objects_3_detal_done", { alp = 1 } );   
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_detal"] = true;
          private.CompleteTask ( "detal" );                                                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );
  
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_insert_near_transistors" );      
        ObjAnimate( "spr_horepair3_rpl_objects_3_detal_done", "alp", 0, 0, func_end_2, 
        {
          0.0, 0, 0,
          0.3, 0, 1
        } );         

    end;

    if ( bool ) then

      ObjSet( item, { alp = 0 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_3_detal_3", { alp = 1 } );
      
      cmn.WrongApply();

    end;

  end;
  --*********************************************************************************************************************
  function private.GetScrewdriver ()

    cmn.SetCursor( CURSOR_NULL );
    
    local item = "spr_horepair3_rpl_objects_2_screwdriver_drag";
    
    private.win_horepair3_rpl.parent = ObjGetRelations( item ).parent;
    
    cmn.GetObjectSfx();
    
    ObjSet( item, { alp = 1, ang = 0 } );
    ObjAttach( item, "int_taskpanel_impl" );
    ObjSet( "spr_horepair3_rpl_objects_2_screwdriver", { alp = 0 } );   

  end;
  --*********************************************************************************************************************
  function private.UseScrewdriver ()

    local item = "spr_horepair3_rpl_objects_2_screwdriver_drag";
    local bool = true;
    SetCursor( CURSOR_DEFAULT );

    if ( ObjIntersect( item, "obj_horepair3_rpl_objects_3_use_screwdriver" ) ) then       
      
        bool = false;

        ObjDelete( item );       
        ObjDelete( "obj_horepair3_rpl_objects_3_use_screwdriver" );
        ObjDelete( "spr_horepair3_rpl_objects_2_screwdriver" );
        
        local func_end_2 = function ()                
          
          ObjDelete( "vid_horepair3_rpl_objects_screw_anim" ); 
          ObjSet( "obj_horepair3_rpl_objects_3_use_detal", { input = true } );
          ObjSet( "spr_horepair3_rpl_objects_3_detal_3", { alp = 1, input = true } ); 
          ObjSet( "spr_horepair3_rpl_objects_3_detal_drag", { input = true } );              
          
          if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_key" ] ) then
            
            ObjSet( "obj_horepair3_rpl_objects_3_use_fuse", { input = true } ); 
            ObjSet( "spr_horepair3_rpl_objects_3_fuse_2", { alp = 1, input = true } ); 
            ObjSet( "spr_horepair3_rpl_objects_3_fuse_drag", { input = true } );                  

          end;          
          ObjDelete( "spr_horepair3_rpl_objects_3_cap_1" );   
          ObjSet( "spr_horepair3_rpl_objects_3_cap_2", { alp = 1 } );
       
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].objects[ "use_screwdriver"] = true;
          private.CompleteTask ( "screwdriver" );                                                          
          
          int.Lock( false );          
    
        end;      
        
        int.Lock( true );   
     
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_horepair3_unscrew_bolts" );    
        VidPlay( "vid_horepair3_rpl_objects_screw_anim", func_end_2 );      

    end;

    if ( bool ) then

      ObjSet( item, { alp = 0, ang = 0.82 } );    
      ObjAttach( item, private.win_horepair3_rpl.parent ); 
      ObjSet( "spr_horepair3_rpl_objects_2_screwdriver", { alp = 1 } );
      
      cmn.WrongApply();

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************