-- name=ho_howardrobe1_rpl
--********************************************************************************************************************
function public.Init ()

  --------------------------------------------------------------------------------------------------
  room.Define( "ho_howardrobe1_rpl" );
  
  game.relations[ "ho_howardrobe1_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_howardrobe1_rpl";

  private.task_name = "win_howardrobe1_rpl";  
  
  private.InitAnimations();

  private.win_howardrobe1_rpl = {};
  private.win_howardrobe1_rpl.sound_counter = 0;

  --------------------------------------------------------------------------------------------
  -- function opn_howardrobe1_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_howardrobe1_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_howardrobe1_rpl", opn_howardrobe1_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_howardrobe1_rpl_func = function ()


  end;
  cmn.AddSubscriber( "win_howardrobe1_rpl", win_howardrobe1_rpl_func );
  --------------------------------------------------------------------------------------------------
  local start_howardrobe1_rpl_func = function ()

    if ( cmn.IsEventStart( "win_howardrobe1_rpl" ) ) then

        local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_howardrobe1_rpl" ].found;

        for i = 1, #ho_found, 1 do
          
            private.win_howardrobe1_rpl.sound_counter = private.win_howardrobe1_rpl.sound_counter + 1;
            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_howardrobe1_rpl", start_howardrobe1_rpl_func );
  --------------------------------------------------------------------------------------------------
  private.win_howardrobe1_rpl.task = { "item_1", "item_2", "item_3", "item_4", "item_5", "item_6", 
                                    "item_7", "item_8", "item_9", "item_10", "item_11", "item_12" };

  for i = 1, #private.win_howardrobe1_rpl.task do

    ObjSet( "spr_howardrobe1_rpl_"..private.win_howardrobe1_rpl.task[ i ], { event_mdown = function () private.CompleteTask( private.win_howardrobe1_rpl.task[ i ] ); end, input = false } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, true );   

  if ( not cmn.IsEventDone( "opn_howardrobe1_rpl" ) ) then

      cmn.SetEventDone( "opn_howardrobe1_rpl" );
      cmn.CallEventHandler( "opn_howardrobe1_rpl" );

  end;

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "item_1",               1, 0, { { "spr_howardrobe1_rpl_item_1"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_2",               1, 0, { { "spr_howardrobe1_rpl_item_2"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_3",               1, 0, { { "spr_howardrobe1_rpl_item_3"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_4",               1, 0, { { "spr_howardrobe1_rpl_item_4"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_5",               1, 0, { { "spr_howardrobe1_rpl_item_5"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_6",               1, 0, { { "spr_howardrobe1_rpl_item_6"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_7",               1, 0, { { "spr_howardrobe1_rpl_item_7"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_8",               1, 0, { { "spr_howardrobe1_rpl_item_8"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_9",               1, 0, { { "spr_howardrobe1_rpl_item_9"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_10",              1, 0, { { "spr_howardrobe1_rpl_item_10"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_11",              1, 0, { { "spr_howardrobe1_rpl_item_11"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_12",              1, 0, { { "spr_howardrobe1_rpl_item_12"  } } );
  
  if ( not cmn.IsEventStart( "win_howardrobe1_rpl" ) ) then

      cmn.InitHo( "howardrobe1_rpl" );
      
  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();
  cmn.StopAllMus();
  --cmn.StopAllEnv( "audio/level1/env/aud_rm_trap1_env", true );
  --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_trap1_env", 1, 1 );
  --cmn.PlayAudio( "mus", "audio/aud_ho_game1_mus", 1, 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.StopMusEnv( false );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_howardrobe1_rpl_panel", "ho_howardrobe1_rpl" );

  for i = 1,#private.win_howardrobe1_rpl.task do 

     local obj = "obj_"..i;
     ObjDelete( obj );

  end;     
  
  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function public.ResetHO ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].start = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].task_check = { 0,0,0,0,0,0,0,0,0,0,0,0 };  

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_click_whoosh" );
  cmn.HoTaskFind( "spr_howardrobe1_rpl_"..name, name );
  for i = 1,#private.win_howardrobe1_rpl.task do

      if ( private.win_howardrobe1_rpl.task[i] == name ) then 

          local object_name = "obj_"..i; 
          local collect_name  = "pfx_howardrobe1_rpl_collect_"..object_name.."_effect";
          ng_global.progress[ ng_global.currentprogress ][ "win_howardrobe1_rpl" ].task_check[ i ] = 1;
          ObjCreate( collect_name, "partsys" );

          if  ( cmn.IsEventDone( "win_howardrobe1_rpl" ) ) then

              --int.Lock( false );

          end;

          ObjSet( collect_name,
          {
            res    = "assets/interface/resources/effects_ho_hint",
            pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
            active = 1, visible = 1, input = 0
          } );

          ObjAttach( collect_name, "obj_howardrobe1_rpl_panel" );
          ObjSet( collect_name, { blendmode = 2, scale_x = 1, scale_y = 1 } );
          --PartSysSetMaskObj( collect_name, object_name );  
          local func_end = function () private.AnimInv( i ); end;
            
          private.win_howardrobe1_rpl.sound_counter = private.win_howardrobe1_rpl.sound_counter + 1;
      
          ObjAnimate( object_name, 8,0,0, func_end,
          { 
              0.0, 0, 1.0,
              0.5, 0, 0.0
          } );
--
      end;

  end;

end;
--*********************************************************************************************************************
function private.Panel ()
  
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_howardrobe1_rpl_panel" , "spr_int_taskpanel" );
  
  if ( not ng_global.progress[ ng_global.currentprogress ]["win_howardrobe1_rpl"].task_check ) then

    ng_global.progress[ng_global.currentprogress]["win_howardrobe1_rpl"].task_check = { 0,0,0,0,0,0,0,0,0,0,0,0 };

  end;

  local posx = -175;
  local tmp = 0;

  ObjSet( "obj_howardrobe1_rpl_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 560, croprect_h = 400 } );

  for i = 1,#private.win_howardrobe1_rpl.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress[ng_global.currentprogress]["win_howardrobe1_rpl"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_howardrobe1_rpl_panel" );
        ObjSet( obj, { pos_x = posx, pos_y = 24, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_howardrobe1_rpl_"..private.win_howardrobe1_rpl.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level1/ho_howardrobe1/layers/inv/inv_"..private.win_howardrobe1_rpl.task[i], scale_x = 1, scale_y = 1 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

         posx = posx + 95;

        if ( tmp == 12 ) then

          ng_global.progress[ ng_global.currentprogress ][ "win_howardrobe1_rpl" ].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_howardrobe1_rpl_"..private.win_howardrobe1_rpl.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;
  local panel_sound = false;

      for i = tmp,#private.win_howardrobe1_rpl.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_howardrobe1_rpl" ].task_check[ i ] ~= 1 then

              if not panel_sound then
                --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_fakel_click" );
                panel_sound = true;
              end;

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-95
              });

              if ObjGet( "obj_"..i ).pos_x-95 == 205 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_howardrobe1_rpl.task do

       local item = "obj_"..i;

       if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_howardrobe1_rpl" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;

          if ( tmp < 6 ) then

             ObjSet( "spr_howardrobe1_rpl_"..private.win_howardrobe1_rpl.task[ i ], { alp = 1, input = 1 } );

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_howardrobe1_rpl", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************