-- name=levelrpl
--************************************************************************************************************************
function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );

  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnGuide, 10 );

  int.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );

  int.WidgetAdd( InterfaceWidget_Effects, 23 );

  int.WidgetAdd( InterfaceWidget_BtnMap, 13 );

  int.WidgetAdd( InterfaceWidget_DialogHo );

  int.ButtonLockAdd();

  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  int.WidgetAdd( InterfaceWidget_Popup, 31 );

  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog );

  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );

  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );

  int.WidgetAdd( InterfaceWidget_Tutorial );
  int.WidgetAdd( InterfaceWidget_Map, 24  );

  int.PanelNotificationAdd();
  int.DeployInvAdd(9);
  int.DialogHintAdd( 10 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );


  private.Init();
  ModLoad( "assets/levels/levelrpl/mod_levelrpl_inv" );
  levelrpl_inv.Init();

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.AchievementsAdd( 10 );

  end;

  --common.LevelLoad( "levelrpl", "rpl", "rm_replayroom", param, private.menu_moduls );
  common.LevelLoad( "levelrpl", "rpl", "rm_replayroom", param );  
  --if IsCollectorsEdition() then

    --common_impl.Collectibles2CoinsLoad();

  --end;

  --private.TutorialSetParams();
  --interface.KeyUpdate();

  --event_show_investigation = "beg_levelrpl";

  --interface.InvestigationButtonCheck();
  
  --interface.PanelProvideShow();
  
end;
--************************************************************************************************************************
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_replayroom"
    ,"ho_hovan1_rpl"
    ,"ho_hotable1_rpl"
    ,"ho_howardrobe1_rpl"
    ,"ho_hosafe1_rpl"
    ,"ho_hoskeleton2_rpl"
    ,"ho_hosecretsection2_rpl"
    ,"ho_hocupboard2_rpl"
    ,"ho_hopast2_rpl"
    ,"ho_hotreasury3_rpl"
    ,"ho_hocardindex3_rpl"
    ,"ho_horepair3_rpl"
    ,"ho_hoalchemybox3_rpl"

    ,"mg_mgassault1_rpl"
    ,"mg_mgtime1_rpl"
    ,"mg_mgdocument1_rpl"
    ,"mg_mgdescent2_rpl"
    ,"mg_mgcatacomb2_rpl"
    ,"mg_mgcreatingacid2_rpl"
    ,"mg_mglock2_rpl"
    ,"mg_mgkeys3_rpl"
    ,"mg_mgcrowd3_rpl"
    ,"mg_mgfight3_rpl"
    ,"mg_mgcrystals_rpl"
    ,"mg_mgdominoes_rpl"
    ,"mg_mgwitch_rpl"
  };

  game.progress_names =
  {
     "beg_levelrpl"
    ,"opn_replayroom"

    ,"opn_hovan1_rpl"
    ,"opn_hotable1_rpl"
    ,"opn_howardrobe1_rpl"
    ,"opn_hosafe1_rpl"
    ,"opn_hoskeleton2_rpl"
    ,"opn_hosecretsection2_rpl"
    ,"opn_hocupboard2_rpl"
    ,"opn_hopast2_rpl"
    ,"opn_hotreasury3_rpl"
    ,"opn_hocardindex3_rpl"
    ,"opn_horepair3_rpl"
    ,"opn_hoalchemybox3_rpl"

    ,"opn_mgassault1_rpl"
    ,"opn_mgtime1_rpl"
    ,"opn_mgdocument1_rpl"
    ,"opn_mgdescent2_rpl"
    ,"opn_mgcatacomb2_rpl"
    ,"opn_mgcreatingacid2_rpl"
    ,"opn_mglock2_rpl"
    ,"opn_mgkeys3_rpl"
    ,"opn_mgcrowd3_rpl"
    ,"opn_mgfight3_rpl"
    ,"opn_mgcrystals_rpl"
    ,"opn_mgdominoes_rpl"
    ,"opn_mgwitch_rpl"

    ,"win_hovan1_rpl"
    ,"win_hotable1_rpl"
    ,"win_howardrobe1_rpl"
    ,"win_hosafe1_rpl"
    ,"win_hoskeleton2_rpl"
    ,"win_hosecretsection2_rpl"
    ,"win_hocupboard2_rpl"
    ,"win_hopast2_rpl"
    ,"win_hotreasury3_rpl"
    ,"win_hocardindex3_rpl"
    ,"win_horepair3_rpl"
    ,"win_hoalchemybox3_rpl"

    ,"win_mgassault1_rpl"
    ,"win_mgtime1_rpl"
    ,"win_mgdocument1_rpl"
    ,"win_mgdescent2_rpl"
    ,"win_mgcatacomb2_rpl"
    ,"win_mgcreatingacid2_rpl"
    ,"win_mglock2_rpl"
    ,"win_mgkeys3_rpl"
    ,"win_mgcrowd3_rpl"
    ,"win_mgfight3_rpl"
    ,"win_mgcrystals_rpl"
    ,"win_mgdominoes_rpl"
    ,"win_mgwitch_rpl"
  };
  
  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      --"rm_collectibles2",
      --"rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;
--************************************************************************************************************************
function public.InventoryDisable(param)
  
  interface.WidgetSetVisible( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );   
  interface.WidgetSetVisible( InterfaceWidget_BtnMap, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnMap, false );   
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );  
  interface.WidgetSetVisible( InterfaceWidget_BtnMenu, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnMenu, false );  
  interface.WidgetSetVisible( InterfaceWidget_BtnSkip, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnSkip, false );  
  if not param then
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide, false );  
    interface.WidgetSetInput( InterfaceWidget_BtnGuide, false );  
  end;
  if ObjGet("int_inventory") then
    ObjStopAnimate( "int_inventory", "alp" );
    ObjSet( "int_inventory", { alp = 0 } );
    ObjSet( "int_inventory_impl", { input = false } );    
  end;
end;
--************************************************************************************************************************